declare namespace FC {
	namespace Desc {
		interface LongSlaveOptions {
			/**
			 * 0 if the slave is not for sale.  Otherwise a string with the name of the market,
			 * partially to determine if laws apply to the market or not.
			 */
			market?: Zeroable<SlaveMarketName>;
			eventDescription?: boolean;
			prisonCrime?: string;
			noArt?: boolean;
		}
	}
}
