/**
 * @typedef {object} BrandStyle
 * @property {string} displayName The way the brand is displayed as a choice in the UI
 * @property {function(void):boolean} [requirements] Function to determine if a brand symbol can be used.
 */
/**
 * @typedef {Object.<string, BrandStyle[]>} BrandStyleList
 * How the brand is saved in the variable.
 */

/** @type {Object.<string, BrandStyleList>} */
App.Medicine.Modification.Brands = {
	personal: {
		"your personal symbol": {displayName: "Your slaving emblem"},
		"your initials": {displayName: "Your initials"},
	},
	dirtyWord: {
		"SLUT": {displayName: "SLUT"},
		"WHORE": {displayName: "WHORE"},
		"SLAVE": {displayName: "SLAVE"},
		"COW": {displayName: "COW"},
		"MEAT": {displayName: "MEAT"},
		"CUMDUMP": {displayName: "CUMDUMP"},
		"LOVER": {displayName: "LOVER"},
	},
	genitalSymbol: {
		"a pussy symbol": {displayName: "Pussy symbol"},
		"an anus symbol": {displayName: "Anus symbol"},
		"a penis symbol": {displayName: "Penis symbol"},
	},
	silhouettes: {
		"a lady silhouette": {displayName: "Lady"},
		"a princess silhouette": {displayName: "Princess"},
		"a queen silhouette": {displayName: "Queen"},
		"an angel silhouette": {displayName: "Angel"},
		"a devil silhouette": {displayName: "Devil"},
	},
	FS: {
		"a racial slur": {
			displayName: "Racial Slur",
			requirements: function(slave) {
				return (
					(V.arcologies[0].FSSupremacist !== "unset" && slave.race !== V.arcologies[0].FSSupremacistRace) ||
					(V.arcologies[0].FSSubjugationist !== "unset" && slave.race === V.arcologies[0].FSSubjugationistRace)
				);
			}
		},
		"how much sex $he needs per day": {
			displayName: "Scores",
			requirements: function(slave) {
				return (V.arcologies[0].FSIntellectualDependency !== "unset");
			}
		},
		"$his average slave aptitude test scores": {
			displayName: "Scores",
			requirements: function(slave) {
				return (V.arcologies[0].FSSlaveProfessionalism !== "unset");
			}
		},
		"the number of children $he has birthed": {
			displayName: "Birth Count",
			requirements: function(slave) {
				return (V.arcologies[0].FSRepopulationFocus !== "unset");
			}
		},
		"a gender symbol": {
			displayName: "Gender Symbol",
			requirements: function(slave) {
				return ((V.arcologies[0].FSGenderRadicalist !== "unset") || (V.arcologies[0].FSGenderFundamentalist !== "unset"));
			}
		},
		"$his own personal symbol": {
			displayName: "Personal Symbol",
			requirements: function(slave) {
				return (V.arcologies[0].FSPaternalist !== "unset");
			}
		},
		"a chain symbol": {
			displayName: "Chain Symbol",
			requirements: function(slave) {
				return (V.arcologies[0].FSDegradationist !== "unset");
			}
		},
		"a Vitruvian man": {
			displayName: "Vitruvian Man",
			requirements: function(slave) {
				return (V.arcologies[0].FSBodyPurist !== "unset");
			}
		},
		"a scalpel": {
			displayName: "Scalpel",
			requirements: function(slave) {
				return (V.arcologies[0].FSTransformationFetishist !== "unset");
			}
		},
		"$his virginity status": {
			displayName: "Virginity Status",
			requirements: function(slave) {
				return (V.arcologies[0].FSYouthPreferentialist !== "unset");
			}
		},
		"$his sexual skills": {
			displayName: "Sexual Skill Info",
			requirements: function(slave) {
				return (V.arcologies[0].FSMaturityPreferentialist !== "unset");
			}
		},
		"$his current height": {
			displayName: "Current height",
			requirements: function(slave) {
				return ((V.arcologies[0].FSPetiteAdmiration !== "unset") || (V.arcologies[0].FSStatuesqueGlorification !== "unset"));
			}
		},
		"$his absolute minimum breast size": {
			displayName: "Breast Floor",
			requirements: function(slave) {
				return (V.arcologies[0].FSSlimnessEnthusiast !== "unset");
			}
		},
		"$his absolute maximum breast size": {
			displayName: "Breast Ceiling",
			requirements: function(slave) {
				return (V.arcologies[0].FSAssetExpansionist !== "unset");
			}
		},
		"$his highest weigh-in": {
			displayName: "Weight Record",
			requirements: function(slave) {
				return (V.arcologies[0].FSHedonisticDecadence !== "unset");
			}
		},
		"a big helping of your favorite food": {
			displayName: "Favorite Food",
			requirements: function(slave) {
				return ((V.arcologies[0].FSHedonisticDecadence !== "unset") && V.PC.refreshmentType === 2);
			}
		},
		"$his body product quality": {
			displayName: "Product Quality",
			requirements: function(slave) {
				return (V.arcologies[0].FSPastoralist !== "unset");
			}
		},
		"$his deadlift record": {
			displayName: "Deadlift Info",
			requirements: function(slave) {
				return (V.arcologies[0].FSPhysicalIdealist !== "unset");
			}
		},
		"a religious symbol": {
			displayName: "Religious Symbol",
			requirements: function(slave) {
				return (V.arcologies[0].FSChattelReligionist !== "unset");
			}
		},
		"the crest of your Republic": {
			displayName: "Republican Crest",
			requirements: function(slave) {
				return (V.arcologies[0].FSRomanRevivalist !== "unset");
			}
		},
		"the symbol of the Aztec gods": {
			displayName: "Seven Serpents",
			requirements: function(slave) {
				return (V.arcologies[0].FSAztecRevivalist !== "unset");
			}
		},
		"the sigil of your Dynasty": {
			displayName: "Dynastic Sigil",
			requirements: function(slave) {
				return (V.arcologies[0].FSEgyptianRevivalist !== "unset");
			}
		},
		"the Shogunate's mon": {
			displayName: "Mon",
			requirements: function(slave) {
				return (V.arcologies[0].FSEdoRevivalist !== "unset");
			}
		},
		"a symbol of the Caliphate": {
			displayName: "Caliphate Symbol",
			requirements: function(slave) {
				return (V.arcologies[0].FSArabianRevivalist !== "unset");
			}
		},
		"your Family Crest": {
			displayName: "Imperial Family Crest",
			requirements: function(slave) {
				return (V.arcologies[0].FSNeoImperialist !== "unset");
			}
		},
		"your Imperial Seal": {
			displayName: "Imperial Seal",
			requirements: function(slave) {
				return (V.arcologies[0].FSChineseRevivalist !== "unset");
			}
		},
	}
};


App.Medicine.Modification.Color = {
	Primary: [
		{value: "auburn"},
		{value: "black"},
		{value: "blazing red"},
		{value: "blonde"},
		{value: "blue-violet"},
		{value: "blue"},
		{value: "brown"},
		{value: "burgundy"},
		{value: "chestnut"},
		{value: "chocolate brown"},
		{value: "copper"},
		{value: "dark blue"},
		{value: "dark brown"},
		{value: "dark orchid"},
		{value: "deep red"},
		{value: "ginger"},
		{value: "golden"},
		{value: "green-yellow"},
		{value: "green"},
		{value: "grey"},
		{value: "hazel"},
		{value: "jet black"},
		{value: "neon blue"},
		{value: "neon green"},
		{value: "neon pink"},
		{value: "pink"},
		{value: "platinum blonde"},
		{value: "purple"},
		{value: "red"},
		{value: "sea green"},
		{value: "silver"},
		{value: "strawberry-blonde"},
		{value: "white"},
	],
	Secondary: [
		{
			title: "None",
			value: ""
		},
		{
			title: "Black",
			value: " with black highlights"
		},
		{
			title: "Blazing red",
			value: " with blazing red highlights"
		},
		{
			title: "Blonde",
			value: " with blonde highlights"
		},
		{
			title: "Grey",
			value: " with grey highlights"
		},
		{
			title: "Neon blue",
			value: " with neon blue highlights"
		},
		{
			title: "Neon green",
			value: " with neon green highlights"
		},
		{
			title: "Neon pink",
			value: " with neon pink highlights"
		},
		{
			title: "Rainbow",
			value: " with rainbow highlights"
		},
		{
			title: "Silver",
			value: " with silver highlights"
		},
		{
			title: "White",
			value: " with white highlights"
		},
	]
};

App.Medicine.Modification.hairStyles = {
	Normal: [
		{
			title: "Afro",
			value: "afro"
		},
		{
			title: "Braided",
			value: "braided"
		},
		{
			title: "Cornrows",
			value: "cornrows"
		},
		{
			title: "Curled",
			value: "curled"
		},
		{
			title: "Dreadlocks",
			value: "dreadlocks"
		},
		{
			title: "Eary",
			value: "eary"
		},
		{
			title: "In a bun",
			value: "bun"
		},
		{
			title: "In a messy bun",
			value: "messy bun"
		},
		{
			title: "In a ponytail",
			value: "ponytail"
		},
		{
			title: "In tails",
			value: "tails"
		},
		{
			title: "Luxurious",
			value: "luxurious"
		},
		{
			title: "Messy",
			value: "messy"
		},
		{
			title: "Neat",
			value: "neat"
		},
		{
			title: "Permed",
			value: "permed"
		},
		{
			title: "Shaved sides",
			value: "strip"
		},
		{
			title: "Up",
			value: "up"
		},
		{
			title: "Half-Shaved",
			value: "undercut"
		},
	],
	Cut: [
		{
			title: "Shaved",
			value: "shaved",
			hLength: 0
		},
		{
			title: "Trimmed short",
			value: "trimmed",
			hLength: 10
		},
		{
			title: "Buzzcut",
			value: "buzzcut",
			hLength: 1
		},
	],
	Length: [
		{
			title: "Very short",
			hLength: 5
		},
		{
			title: "Short",
			hLength: 10
		},
		{
			title: "Shoulder length",
			hLength: 30
		},
		{
			title: "Long",
			hLength: 60
		},
		{
			title: "Very long",
			hLength: 100
		},
	]
};

App.Medicine.Modification.eyeColor = [
	{value: "amber"},
	{value: "black"},
	{value: "blue"},
	{value: "brown"},
	{value: "green"},
	{value: "hazel"},
	{value: "orange"},
	{value: "pale-grey"},
	{value: "pink"},
	{value: "red"},
	{value: "sky-blue"},
	{value: "turquoise"},
	{value: "white"},
	{value: "yellow"}
];

App.Medicine.Modification.eyeShape = [
	{value: "circular"},
	{value: "almond-shaped"},
	{value: "bright"},
	{value: "catlike"},
	{value: "demonic"},
	{value: "devilish"},
	{value: "goat-like"},
	{value: "heart-shaped"},
	{value: "hypnotic"},
	{value: "serpent-like"},
	{value: "star-shaped"},
	{value: "teary"},
	{value: "vacant"},
	{value: "wide-eyed"}
];

App.Medicine.Modification.naturalSkins = ["pure white", "ivory", "white", "extremely pale", "very pale", "pale", "extremely fair", "very fair", "fair", "light", "light olive", "tan", "olive", "bronze", "dark olive", "dark", "light beige", "beige", "dark beige", "light brown", "brown", "dark brown", "black", "ebony", "pure black"];
App.Medicine.Modification.dyedSkins = ["camouflage patterned", "dyed blue", "dyed gray", "dyed green", "dyed pink", "dyed red", "tiger striped"];
App.Medicine.Modification.naturalNippleColors = ["black", "brown", "dark brown", "ebony", "ivory", "light brown", "pale pink", "pink"];
App.Medicine.Modification.eyebrowStyles = new Set(["shaved", "straight", "rounded", "natural", "slanted inwards", "slanted outwards", "high-arched", "elongated", "shortened", "curved"]);
App.Medicine.Modification.eyebrowFullness = new Set(["pencil-thin", "thin", "threaded", "natural", "tapered", "thick", "bushy"]);
App.Medicine.Modification.pubicStyles = new Set(["waxed", "in a strip", "neat", "bushy", "bushy in the front and neat in the rear", "very bushy"]);
App.Medicine.Modification.armpitStyles = new Set(["waxed", "shaved", "neat", "bushy"]);
App.Medicine.Modification.hornColor = new Set(["golden", "copper", "red", "deep red", "green", "pink", "dark brown", "brown", "burgundy", "jet black", "black", "grey", "silver", "white", "blue-violet", "purple", "dark orchid", "sea green", "green-yellow", "dark blue", "blazing red", "neon green", "neon blue", "neon pink"]);
