App.EndWeek.rulesAssistantReport = function() {
	const frag = $(document.createDocumentFragment());
	for (const slave of V.slaves) {
		if (slave.useRulesAssistant === 1) {
			try {
				frag.append(DefaultRules(slave));
			} catch (e) {
				console.log("Exception thrown in rule evaluation:", slave, e);
				frag.append(`<p><span class="error">Exception thrown executing Rules Assistant for ${SlaveFullName(slave)}: "${e.message}". One of your rules is probably broken.</span></p>`);
			}
		}
	}
	return frag[0];
};
