/**
 * Sends a child to the Incubator if it has room
 * @param {App.Entity.SlaveState|App.Entity.InfantState} child
 */
App.Facilities.Incubator.newChild = function(child) {
	let fullAdapt;
	child.growTime = Math.trunc(V.targetAge * 52);
	child.incubatorPregAdaptationPower = V.incubatorPregAdaptationPower;
	if (V.incubatorPregAdaptationPower === 1) {
		fullAdapt = 45000 / 2000;
	} else if (V.incubatorPregAdaptationPower === 2) {
		fullAdapt = 100000 / 2000;
	} else if (V.incubatorPregAdaptationPower === 3) {
		fullAdapt = 150000 / 2000;
	} else {
		fullAdapt = 15000 / 2000;
	}
	child.incubatorPregAdaptationInWeek = (fullAdapt - child.pregAdaptation) / child.growTime;
	V.tanks.push(child);
};
