/**
 * @param {App.Entity.SlaveState} slave
 * @returns {string}
 */
App.Desc.heightImplant = function(slave) {
	let r = [];
	const {his} = getPronouns(slave);
	if (slave.heightImplant > 1) {
		r = limbs();
		r.push(`are wrong; it's obvious that they have been artificially lengthened.`);
	} else if (slave.heightImplant > 0) {
		r = limbs();
		r.push(`are odd, as though they have been artificially lengthened.`);
	} else if (slave.heightImplant < -1) {
		r = limbs();
		r.push(`are wrong; it's obvious that they have been artificially shortened.`);
	} else if (slave.heightImplant < 0) {
		r = limbs();
		r.push(`are odd, as though they have been artificially shortened.`);
	}

	function limbs() {
		const r = [];
		r.push(`The proportions of ${his}`);
		if (hasAnyArms(slave)) {
			if (hasBothArms(slave)) {
				r.push(`arms`);
			} else {
				r.push(`arm`);
			}
			if (hasAnyLegs(slave)) {
				r.push(`and`);
			}
		}
		if (hasAnyLegs(slave)) {
			if (hasBothLegs(slave)) {
				r.push(`legs`);
			} else {
				r.push(`leg`);
			}
		}
		return r;
	}
	return r.join(" ");
};
