@echo off

set back=%cd%
for /d %%i in (%~dp0\themes\*) do (
    CALL :compileDirectory %%i
)
cd %back%

EXIT /B %ERRORLEVEL%

:compileDirectory
REM ~1 is an absolute path, get name of directory here
REM https://stackoverflow.com/a/5480568
set var1=%~1%
set var2=%var1%
set i=0

:loopprocess
for /F "tokens=1* delims=\" %%A in ( "%var1%" ) do (
  set /A i+=1
  set var1=%%B
  goto loopprocess
)

for /F "tokens=%i% delims=\" %%G in ( "%var2%" ) do set last=%%G

REM compile
CALL devTools/concatFiles.bat "%%~1" "*.css" bin\"%last%".css
EXIT /B 0
