/* ### Scheduled Events ### */
new App.DomPassage("SE Burst",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Scheduled Event";

		return allBursts();
	}
);

new App.DomPassage("SE Death",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Scheduled Event";

		return allDeaths();
	}
);

new App.DomPassage("SE Birth",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Scheduled Event";

		return allBirths();
	}
);

new App.DomPassage("SE pit fight", () => App.Facilities.Pit.fight(V.pit.lethal));

new App.DomPassage("SE pc birthday", () => App.Events.pcBirthday.runEvent());

/* ### Non Random Events ### */

new App.DomPassage("Murder Attempt",
	() => {
		if (V.event === "slave trade") {
			return App.Events.murderAttemptFollowup("slave", V.illegalDeals.slave.company, V.illegalDeals.slave.type);
		} else if (V.event === "trade deal") {
			return App.Events.murderAttemptFollowup("trade", V.illegalDeals.trade.company);
		} else if (V.event === "military deal") {
			return App.Events.murderAttemptFollowup("military", V.illegalDeals.military.company);
		} else {
			return App.Events.murderAttempt();
		}
	}
);

/* ### Random Events ### */

new App.DomPassage("JS Random Event",
	() => {
		V.nextButton = "Continue";

		const d = document.createElement("div");
		V.event.execute(d);
		return d;
	}
);
