// @ts-nocheck
App.Update.policies = function() {
	function convertMain(variable, pro, anti) {
		if (V[pro]) {
			V.policies[variable] = 1;
		} else if (V[anti]) {
			V.policies[variable] = -1;
		}
	}

	function convertRetirement(variable, retireType, amountRequired) {
		if (V[retireType] && V[amountRequired]) {
			V.policies.retirement[variable] = V[amountRequired];
		}
	}

	if(V.policies.gumjobFetishism == null) {
		V.policies.gumjobFetishism = 0;
	}

	if(V.policies.gumjobFetishismSMR == null) {
		V.policies.gumjobFetishismSMR = 0;
	}

	// Spelling fixes:
	V.policies.sexualOpenness = V.policies.sexualOpenness || V.policies.sexualOpeness || 0;
	V.policies.bestialityOpenness = V.policies.bestialityOpenness || V.policies.bestialityOpeness || 0;
	V.policies.immigrationCash = V.policies.immigrationCash || V.policies.immmigrationCash || 0;
	V.policies.immigrationRep = V.policies.immigrationRep || V.policies.immmigrationRep || 0;

	if (V.releaseID < 1069) {
		V.policies.childProtectionAct = V.childProtectionAct;
		V.policies.culturalOpenness = V.CulturalOpenness;
		V.policies.sexualOpenness = V.sexualOpenness || V.sexualOpeness;
		V.policies.proRefugees = V.ProRefugees;
		V.policies.publicFuckdolls = V.publicFuckdolls;

		V.policies.proRecruitment = V.ProRecruitment;
		V.policies.cash4Babies = V.Cash4Babies;
		V.policies.regularParties = V.RegularParties;
		V.policies.publicPA = V.PAPublic;
		V.policies.coursingAssociation = V.CoursingAssociation;

		V.policies.raidingMercenaries = V.RaidingMercenaries;
		V.policies.mixedMarriage = V.MixedMarriage;
		V.policies.goodImageCampaign = V.goodImageCampaign;
		V.policies.alwaysSubsidizeRep = V.alwaysSubsidizeRep;
		V.policies.alwaysSubsidizeGrowth = V.alwaysSubsidizeGrowth;

		convertMain('immigrationCash', 'ProImmigrationCash', 'AntiImmigrationCash');
		convertMain('immigrationRep', 'ProImmigrationRep', 'AntiImmigrationRep');
		convertMain('enslavementCash', 'ProEnslavementCash', 'AntiEnslavementCash');
		convertMain('enslavementRep', 'ProEnslavementRep', 'AntiEnslavementRep');
		convertMain('cashForRep', 'CashForRep', 'RepForCash');

		convertMain('oralAppeal', 'OralEncouragement', 'OralDiscouragement');
		convertMain('vaginalAppeal', 'VaginalEncouragement', 'VaginalDiscouragement');
		convertMain('analAppeal', 'AnalEncouragement', 'AnalDiscouragement');

		convertRetirement('sex', 'SexMilestoneRetirement', 'retirementSex');
		convertRetirement('milk', 'MilkMilestoneRetirement', 'retirementMilk');
		convertRetirement('cum', 'CumMilestoneRetirement', 'retirementCum');
		convertRetirement('births', 'BirthsMilestoneRetirement', 'retirementBirths');
		convertRetirement('kills', 'KillsMilestoneRetirement', 'retirementKills');

		if (V.BioreactorRetirement) {
			V.policies.retirement.fate = "bioreactor";
		} else if (V.ArcadeRetirement) {
			V.policies.retirement.fate = "arcade";
		} else if (V.CitizenRetirement) {
			V.policies.retirement.fate = "citizen";
		}

		V.policies.retirement.menial2Citizen = V.citizenRetirementMenials;
		V.policies.retirement.customAgePolicy = V.policies.retirement.customAgePolicySet || V.CustomRetirementAgePolicy;
		V.policies.retirement.physicalAgePolicy = V.PhysicalRetirementAgePolicy;

		V.policies.SMR.basicSMR = V.BasicSMR;
		V.policies.SMR.healthInspectionSMR = V.HealthInspectionSMR;
		V.policies.SMR.educationSMR = V.EducationSMR;
		V.policies.SMR.frigiditySMR = V.FrigiditySMR;

		V.policies.SMR.weightSMR = V.BasicWeightSMR;
		V.policies.SMR.honestySMR = V.HonestySMR;

		V.policies.SMR.beauty.basicSMR = V.BasicBeautySMR;
		V.policies.SMR.beauty.qualitySMR = V.QualityBeautySMR;

		V.policies.SMR.height.basicSMR = V.BasicHeightSMR;
		V.policies.SMR.height.advancedSMR = V.AdvancedHeightSMR;

		V.policies.SMR.intelligence.basicSMR = V.BasicIntelligenceSMR;
		V.policies.SMR.intelligence.qualitySMR = V.QualityIntelligenceSMR;

		V.policies.SMR.eugenics.faceSMR = V.FaceEugenicsSMR;
		V.policies.SMR.eugenics.heightSMR = V.HeightEugenicsSMR;
		V.policies.SMR.eugenics.intelligenceSMR = V.IntelligenceEugenicsSMR;
	}
};
