globalThis.allBursts = function() {
	const el = new DocumentFragment();
	for (const slave of V.slaves) {
		if (burstCheck(slave)) {
			if (slave.womb.length > 0) {
				el.append(birth(slave));
			} else {
				el.append(pop(slave));
			}
			removeSlave(slave);
			el.append(sectionBreak());
		}
	}
	V.burstee = 0;

	return el;

	/**
	 *
	 * @param {App.Entity.SlaveState} slave
	 * @returns {DocumentFragment}
	 */
	function pop(slave) {
		const el = new DocumentFragment();
		const r = [];
		const {
			He, His,
			he, his, him
		} = getPronouns(slave);
		if (V.seeImages && V.seeReportImages) {
			r.push(
				App.UI.DOM.makeElement("div", App.Art.SlaveArtElement(slave, 0, 0), ["imageRef", "medImg"])
			);
		}
		r.push(`As ${slave.slaveName} is going about ${his} business with ${his} overfilled`);
		if (slave.inflation !== 0) {
			r.push(slave.inflationType);
		}
		r.push(`belly, ${he} can't help but feel exhausted. ${His} health has been poor lately and the pressure in ${his} organs is not helping things. ${He} immediately knows something is wrong when an intense pain runs through ${his} middle and ${his} load shifts threateningly.`);
		if (slave.inflation !== 0) {
			r.push(`Blood and ${slave.inflationType} leak`);
		} else {
			r.push(`Blood leaks`);
		}
		(`from ${his} rear as ${his} body cavity fills with the contents of ${his} digestive tract. The skin of ${his} taut belly reddens as the pressure against it builds. As ${he} takes ${his} last breath, ${he} falls forward, ${his} weight landing upon ${his} straining stomach. With a gush, ${he} ruptures, flooding the area around ${him} with`);
		if (slave.inflation !== 0) {
			r.push(`blood, guts and ${slave.inflationType}.`);
		} else {
			r.push(`blood and guts.`);
		}
		el.append(r.join(" "));
		el.append(horrifiedSlaves(slave));
		return el;
	}

	function sectionBreak() {
		const hr = document.createElement("hr");
		hr.style.margin = "0";
		return hr;
	}
};

/**
 *
 * @param {App.Entity.SlaveState} slave
 * @returns {HTMLElement}
 */
globalThis.horrifiedSlaves = function(slave) {
	const el = document.createElement("p");
	const {his} = getPronouns(slave);
	el.append(`Word of the late slave and ${his} gruesome fate spread fast, `);
	App.UI.DOM.appendNewElement("span", el, "terrifying", "gold");
	el.append(` your untrusting slaves.`);
	for (const bystander of V.slaves) {
		if (bystander.trust <= 50) {
			if (slave.inflation > 0) {
				bystander.trust -= (Math.pow(slave.inflation, 3) * 5);
			} else {
				bystander.trust -= 10;
			}
		}
	}
	return el;
};

