/**
 * @param {App.Entity.SlaveState} slave
 * @returns {string}
 */
App.Desc.legs = function(slave) {
	const r = [];
	const {
		his, He
	} = getPronouns(slave);

	if (hasAnyNaturalLegs(slave)) {
		if (slave.weight > 190) {
			r.push(`${He} has`);
			if (hasBothNaturalLegs(slave)) {
				r.push(`extremely fat legs with immense soft, rather uneven`);
				if (slave.muscles > 5) {
					r.push(`thighs and`);
				} else {
					r.push(`thighs.`);
				}
			} else {
				r.push(`an extremely fat leg with an immense soft, rather uneven`);
				if (slave.muscles > 5) {
					r.push(`thigh and`);
				} else {
					r.push(`thigh.`);
				}
			}
		} else if (slave.weight > 160) {
			r.push(`${He} has`);
			if (hasBothNaturalLegs(slave)) {
				r.push(`very fat legs with massively thick, soft, somewhat uneven`);
				if (slave.muscles > 5) {
					r.push(`thighs and`);
				} else {
					r.push(`thighs.`);
				}
			} else {
				r.push(`a very fat leg with a massively thick, soft, somewhat uneven`);
				if (slave.muscles > 5) {
					r.push(`thigh and`);
				} else {
					r.push(`thigh.`);
				}
			}
		} else if (slave.weight > 130) {
			r.push(`${He} has`);
			if (hasBothNaturalLegs(slave)) {
				r.push(`fat legs with hugely thick, soft`);
				if (slave.muscles > 5) {
					r.push(`thighs and`);
				} else {
					r.push(`thighs.`);
				}
			} else {
				r.push(`a fat leg with a hugely thick, soft`);
				if (slave.muscles > 5) {
					r.push(`thigh and`);
				} else {
					r.push(`thigh.`);
				}
			}
		} else if (slave.weight > 97) {
			r.push(`${He} has`);
			if (hasBothNaturalLegs(slave)) {
				r.push(`fat legs with thick, soft`);
				if (slave.muscles > 5) {
					r.push(`thighs and`);
				} else {
					r.push(`thighs.`);
				}
			} else {
				r.push(`a fat leg with a thick, soft`);
				if (slave.muscles > 5) {
					r.push(`thigh and`);
				} else {
					r.push(`thigh.`);
				}
			}
		} else if (slave.weight > 95) {
			r.push(`${He} has`);
			if (hasBothNaturalLegs(slave)) {
				r.push(`normal legs with thick, soft`);
				if (slave.muscles > 5) {
					r.push(`thighs and`);
				} else {
					r.push(`thighs.`);
				}
			} else {
				r.push(`a normal leg with a thick, soft`);
				if (slave.muscles > 5) {
					r.push(`thigh and`);
				} else {
					r.push(`thigh.`);
				}
			}
		} else if (slave.muscles > 5) {
			r.push(`${He} has`);
			if (hasBothNaturalLegs(slave)) {
				r.push(`relatively normal legs and thighs`);
			} else {
				r.push(`a relatively normal leg and thigh`);
			}
			r.push(`with`);
		}

		if (slave.muscles > 95) {
			if (slave.weight > 95) {
				r.push(`huge muscles hidden beneath ${his} soft flab.`);
			} else {
				r.push(`huge muscles.`);
			}
		} else if (slave.muscles > 30) {
			if (slave.weight > 95) {
				r.push(`obvious muscles hidden beneath ${his} soft flab.`);
			} else {
				r.push(`obvious muscles.`);
			}
		} else if (slave.muscles > 5) {
			if (slave.weight > 30) {
				r.push(`toned muscles hidden beneath ${his} soft flab.`);
			} else {
				r.push(`toned muscles.`);
			}
		} else {
			// barely any muscle in them.
		}
	}
	return r.join(" ");
};

