/**
 * @param {App.Entity.SlaveState} slave
 * @returns {string}
 */
App.Desc.relationRival = function(slave) {
	const r = [];
	const {
		his, He
	} = getPronouns(slave);

	r.push(relative());
	r.push(rival());

	return r.join(" ");

	function relative() {
		if (slave.relationship >= 3 && totalRelatives(slave) > 0) {
			const lover = getSlave(slave.relationshipTarget);
			if (lover) {
				if (relativeTerm(slave, lover) !== null) {
					return `${He} is in an <span class="lightgreen">incestuous relationship with ${his} ${relativeTerm(slave, lover)}, ${SlaveFullName(lover)}.</span>`;
				}
			}
		} else if (slave.relationship <= -2) {
			if (relativeTerm(slave, V.PC) !== null) {
				return `${He} is in an <span class="lightgreen">incestuous relationship with ${his} ${relativeTerm(slave, V.PC)}, you.</span>`;
			}
		}
	}

	function rival() {
		if (slave.rivalry !== 0) {
			if (getSlave(slave.rivalryTarget)) {
				if (slave.rivalry <= 1) {
					return `${He} <span class="lightsalmon">dislikes</span> ${SlaveFullName(getSlave(slave.rivalryTarget))}.`;
				} else if (slave.rivalry <= 2) {
					return `${He} is ${SlaveFullName(getSlave(slave.rivalryTarget))}'s <span class="lightsalmon">rival.</span>`;
				} else {
					return `${He} <span class="lightsalmon">bitterly hates</span> ${SlaveFullName(getSlave(slave.rivalryTarget))}.`;
				}
			}
		}
	}
};

