App.Intro.editFamily = function(slave) {
	const el = new DocumentFragment();
	const _allowPCFamily = (V.freshPC === 1 || V.saveImported === 0);
	const {His, his} = getPronouns(slave);

	// Checks to make sure a slave is not the active slave's parent.
	const isNotMom = (s) => ((s.mother !== slave.mother) || (slave.mother === 0));
	const isNotDad = (s) => ((s.father !== slave.father) || (slave.father === 0));

	const editFamily = makeElWithID("edit-family");
	editFamily.append(makeFamilyTable());
	editFamily.append(makeElWithID("family-tree"));
	el.append(editFamily);

	return el;

	function makeFamilyTable() {
		const familyTable = makeElWithID("family-table");
		familyTable.append(summary());
		familyTable.append(makeElWithID("dont-be-dumb"));
		familyTable.append(mother());
		familyTable.append(sameMotherAs());
		familyTable.append(father());
		familyTable.append(sameFatherAs());
		familyTable.append(motherOfTheChildren());
		familyTable.append(fatherOfTheChildren());
		if (_allowPCFamily) {
			familyTable.append(resetAllRelativesOfPC());
		}
		return familyTable;
	}

	function summary() {
		const familySummary = App.UI.DOM.makeElement("p");
		$(familySummary).append(App.Desc.family(slave));
		return familySummary;
	}

	function mother() {
		const div = document.createElement("div");
		const linkArray = [];

		div.append(`${slave.slaveName}'s mother is ${parentName("mother")}. `);

		linkArray.push(
			App.UI.DOM.link(
				"Reset",
				() => {
					slave.mother = 0;
					refresh();
				}
			)
		);

		if (V.PC.vagina > 0 && isNotMom(V.PC) && ((V.PC.actualAge - slave.actualAge) >= V.fertilityAge) && _allowPCFamily) {
			linkArray.push(
				App.UI.DOM.link(
					"You",
					() => {
						slave.mother = V.PC.ID;
						refresh();
					}
				)
			);
		}

		for (const potentialRel of V.slaves) {
			if (potentialRel.vagina > 0 && isNotMom(potentialRel) && ((potentialRel.actualAge - slave.actualAge) >= potentialRel.pubertyAgeXX) && potentialRel.newGamePlus === 0) {
				linkArray.push(
					App.UI.DOM.link(
						potentialRel.slaveName,
						() => {
							slave.mother = potentialRel.ID;
							refresh();
						}
					)
				);
			}
		}

		div.append(App.UI.DOM.generateLinksStrip(linkArray));

		return div;
	}

	function father() {
		const div = document.createElement("div");
		const linkArray = [];

		div.append(`${slave.slaveName}'s father is ${parentName("father")}. `);

		linkArray.push(
			App.UI.DOM.link(
				"Reset",
				() => {
					slave.father = 0;
					refresh();
				}
			)
		);

		if (V.PC.dick > 0 && isNotDad(V.PC) && ((V.PC.actualAge - slave.actualAge) >= V.potencyAge) && _allowPCFamily) {
			linkArray.push(
				App.UI.DOM.link(
					"You",
					() => {
						slave.father = V.PC.ID;
						refresh();
					}
				)
			);
		}

		for (const potentialRel of V.slaves) {
			if (potentialRel.dick > 0 && isNotDad(potentialRel) && ((potentialRel.actualAge - slave.actualAge) >= potentialRel.pubertyAgeXY) && potentialRel.newGamePlus === 0) {
				linkArray.push(
					App.UI.DOM.link(
						potentialRel.slaveName,
						() => {
							slave.father = potentialRel.ID;
							refresh();
						}
					)
				);
			}
		}

		div.append(App.UI.DOM.generateLinksStrip(linkArray));

		return div;
	}

	function sameMotherAs() {
		const div = document.createElement("div");
		const linkArray = [];

		if (slave.mother === -1) {
			div.append(`You are ${his} mother, and also the mother of: `);
		} else {
			div.append(`${His} mom, ${parentName("mother")}, is also the mother of: `);
		}

		div.append(App.StartingGirls.listOfSlavesWithParent('mother', slave.mother), " ");

		linkArray.push(
			App.UI.DOM.link(
				"Reset",
				() => {
					slave.mother = 0;
					refresh();
				}
			)
		);

		if ((slave.mother !== V.PC.ID) && (V.PC.mother !== slave.ID) && _allowPCFamily) {
			linkArray.push(
				App.UI.DOM.link(
					"You",
					() => {
						setRel(V.PC);
						refresh();
					}
				)
			);
		}

		for (const potentialRel of V.slaves) {
			if ((slave.mother !== potentialRel.ID) && (potentialRel.mother !== slave.ID) && potentialRel.newGamePlus === 0) {
				linkArray.push(
					App.UI.DOM.link(
						potentialRel.slaveName,
						() => {
							setRel(potentialRel);
							refresh();
						}
					)
				);
			}
		}

		div.append(App.UI.DOM.generateLinksStrip(linkArray));

		return div;

		function setRel(potentialRel) {
			if (potentialRel.mother !== 0) {
				slave.mother = potentialRel.mother;
			} else if (slave.mother !== 0) {
				potentialRel.mother = slave.mother;
			} else {
				slave.mother = -20 - 2*slave.ID;
				potentialRel.mother = slave.mother;
			}
		}
	}

	function sameFatherAs() {
		const div = document.createElement("div");
		const linkArray = [];

		if (slave.father === -1) {
			div.append(`You are ${his} father, and also the father of: `);
		} else {
			div.append(`${His} dad, ${parentName("father")}, is also the father of: `);
		}

		div.append(App.StartingGirls.listOfSlavesWithParent('father', slave.father), " ");

		linkArray.push(
			App.UI.DOM.link(
				"Reset",
				() => {
					slave.father = 0;
					refresh();
				}
			)
		);

		if ((slave.father !== V.PC.ID) && (V.PC.father !== slave.ID) && _allowPCFamily) {
			linkArray.push(
				App.UI.DOM.link(
					"You",
					() => {
						setRel(V.PC);
						refresh();
					}
				)
			);
		}

		for (const potentialRel of V.slaves) {
			if ((slave.father !== potentialRel.ID) && (potentialRel.father !== slave.ID) && potentialRel.newGamePlus === 0) {
				linkArray.push(
					App.UI.DOM.link(
						potentialRel.slaveName,
						() => {
							setRel(potentialRel);
							refresh();
						}
					)
				);
			}
		}

		div.append(App.UI.DOM.generateLinksStrip(linkArray));

		return div;

		function setRel(potentialRel) {
			if (potentialRel.father !== 0) {
				slave.father = potentialRel.father;
			} else if (slave.father !== 0) {
				potentialRel.father = slave.father;
			} else {
				slave.father = -20 - 2*slave.ID;
				potentialRel.father = slave.father;
			}
		}
	}

	function motherOfTheChildren() {
		const div = document.createElement("div");
		const linkArray = [];

		div.append(motheredNames());

		linkArray.push(
			App.UI.DOM.link(
				"Reset",
				() => {
					for (const s of V.slaves) {
						if (s.mother === slave.ID && s.newGamePlus === 0) {
							s.mother = 0;
						}
					}
					if (V.PC.mother === slave.ID && _allowPCFamily) {
						V.PC.mother = 0;
					}
					refresh();
				}
			)
		);

		if (slave.vagina >= 0) {
			if (isNotMom(V.PC) && (slave.actualAge - V.PC.actualAge) >= V.fertilityAge && _allowPCFamily) {
				linkArray.push(
					App.UI.DOM.link(
						"You",
						() => {
							setRel(V.PC);
							refresh();
						}
					)
				);
			}

			for (const potentialRel of V.slaves) {
				if (isNotMom(potentialRel) && ((potentialRel.actualAge - slave.actualAge) >= potentialRel.pubertyAgeXX) && potentialRel.newGamePlus === 0) {
					linkArray.push(
						App.UI.DOM.link(
							potentialRel.slaveName,
							() => {
								setRel(potentialRel);
								refresh();
							}
						)
					);
				}
			}
		}

		div.append(App.UI.DOM.generateLinksStrip(linkArray));

		return div;

		function setRel(potentialRel) {
			potentialRel.mother = slave.ID;
			if (slave.vagina === 0) {
				slave.vagina = 1;
			}
		}
	}

	function motheredNames() {
		const children = App.StartingGirls.listOfSlavesWithParent("mother", slave.ID);
		if (children) {
			return `${slave.slaveName} is the mother of these children: ${children}. Add: `;
		} else {
			return `${slave.slaveName} is not a mother to any children yet. Add: `;
		}
	}

	function fatherOfTheChildren() {
		const div = document.createElement("div");
		const linkArray = [];

		div.append(fatheredNames());

		linkArray.push(
			App.UI.DOM.link(
				"Reset",
				() => {
					for (const s of V.slaves) {
						if (s.father === slave.ID && s.newGamePlus === 0) {
							s.father = 0;
						}
					}
					if (V.PC.father === slave.ID && _allowPCFamily) {
						V.PC.father = 0;
					}
					refresh();
				}
			)
		);

		if (slave.dick > 0) {
			if (isNotDad(V.PC) && (slave.actualAge - V.PC.actualAge) >= V.potencyAge && _allowPCFamily) {
				linkArray.push(
					App.UI.DOM.link(
						"You",
						() => {
							V.PC.father = slave.ID;
							refresh();
						}
					)
				);
			}

			for (const potentialRel of V.slaves) {
				if (isNotDad(potentialRel) && ((potentialRel.actualAge - slave.actualAge) >= potentialRel.pubertyAgeXX) && potentialRel.newGamePlus === 0) {
					linkArray.push(
						App.UI.DOM.link(
							potentialRel.slaveName,
							() => {
								potentialRel.father = slave.ID;
								refresh();
							}
						)
					);
				}
			}
		}

		div.append(App.UI.DOM.generateLinksStrip(linkArray));

		return div;
	}

	function fatheredNames() {
		const children = App.StartingGirls.listOfSlavesWithParent("father", slave.ID);
		if (children) {
			return `${slave.slaveName} is the father of these children: ${children}. Add: `;
		} else {
			return `${slave.slaveName} is not a father to any children yet. Add: `;
		}
	}

	function resetAllRelativesOfPC() {
		return App.UI.DOM.makeElement(
			"div",
			App.UI.DOM.link(
				"Reset ALL PC Relatives",
				() => {
					let _sameMother = 0;
					let _sameFather = 0;

					for (const s of V.slaves) {
						if (s.newGamePlus === 0) {
							if (s.mother === V.PC.ID) {
								s.mother = 0;
							}
							if (s.father === V.PC.ID) {
								s.father = 0;
							}
							if (s.mother === V.PC.mother) {
								_sameMother++;
							}
							if (s.father === V.PC.father) {
								_sameFather++;
							}
						}
					}
					if (_sameMother === 0 && slave.mother === V.PC.mother) {
						slave.mother = 0;
					}
					if (_sameFather === 0 && slave.father === V.PC.father) {
						slave.father = 0;
					}
					for (let _efw = 0; (_efw < V.slaves.length && (_sameMother === 1 || _sameFather === 1)); _efw++) {
						if (V.slaves[_efw].newGamePlus === 0) {
							if (V.slaves[_efw].mother === V.PC.mother && _sameMother === 1) {
								V.slaves[_efw].mother = 0;
								_sameMother = 0;
							}
							if (V.slaves[_efw].father === V.PC.father && _sameFather === 1) {
								V.slaves[_efw].father = 0;
								_sameFather = 0;
							}
						}
					}
					if (slave.mother === V.PC.ID) {
						slave.mother = 0;
					}
					if (slave.father === V.PC.ID) {
						slave.father = 0;
					}
					V.PC.father = 0;
					V.PC.mother = 0;
					refresh();
				}
			)
		);
	}

	function makeElWithID(id, elType = "div") {
		const el = document.createElement(elType);
		el.id = id;
		return el;
	}

	/**
	 *
	 * @param {string} rel "mother", etc.  Property of slave object.
	 */
	function parentName(rel) {
		if (slave[rel] === V.PC.ID) {
			return `You`;
		} else {
			const relObj = getSlave(slave[rel]);
			return relObj ? relObj.slaveName : "unknown to you";
		}
	}

	function refresh() {
		jQuery('#family-table').replaceWith(makeFamilyTable);
		jQuery('#dont-be-dumb').empty().append(App.UI.DOM.makeElement("div", "You will break things by making impossible relations such as being your own father. If you do this, clearing all PC relations will fix it. Probably.", "note"));
		App.StartingGirls.uncommittedFamilyTree(slave);
	}
};
