/** Generate a new slave for the starting girls passage
 * @returns {App.Entity.SlaveState}
 */
App.StartingGirls.generate = function(params) {
	let slave = GenerateNewSlave(null, params);
	setHealth(slave, 0, 0, 0, 0, 0);
	slave.devotion = 0;
	slave.trust = 0;
	slave.sexualQuirk = "none";
	slave.behavioralQuirk = "none";
	slave.fetishKnown = 1;
	slave.canRecruit = 0;
	slave.weekAcquired = 0;

	return slave;
};

/** Make sure user-entered values aren't crazy for starting girls
 * @param {App.Entity.SlaveState} slave
 */
App.StartingGirls.cleanup = function(slave) {
	slave.actualAge = Math.clamp(slave.actualAge, V.minimumSlaveAge, V.retirementAge-1) || 18;
	slave.physicalAge = slave.actualAge;
	slave.visualAge = slave.actualAge;
	slave.ovaryAge = slave.actualAge;
	slave.birthWeek = Math.clamp(slave.birthWeek, 0, 51) || 0;

	slave.devotion = Math.clamp(slave.devotion, -100, 100) || 0;
	slave.trust = Math.clamp(slave.trust, -100, 100) || 0;
	if (slave.indenture >= 0) {
		slave.indenture = Math.clamp(slave.indenture, 26, 208) || 26;
	}

	slave.height = Math.clamp(slave.height, 85, 274) || 140;
	slave.boobs = Math.clamp(Math.trunc(slave.boobs/50)*50, 0, 50000) || 200;
	slave.hLength = Math.clamp(slave.hLength, 0, 500) || 40;

	resetEyeColor(slave, "both");
	slave.origRace = slave.race;

	if (slave.balls === 0) {
		slave.scrotum = 0;
	}
	if (slave.vagina === -1) {
		slave.vaginaLube = 0;
	}
	if (slave.preg > 0) {
		if (slave.pregSource !== -1) {
			slave.pregSource = 0;
		}
	}
	if (slave.ovaries === 0) {
		slave.preg = 0;
		slave.pregType = 0;
		slave.pregSource = 0;
		slave.pregWeek = 0;
		slave.pregKnown = 0;
		slave.belly = 0;
		slave.bellyPreg = 0;
	}
	if (slave.analArea < slave.anus) {
		slave.analArea = slave.anus;
	}

	slave.father = Number(slave.father) || 0;
	slave.mother = Number(slave.mother) || 0;

	if (slave.counter.birthsTotal > 0) {
		if (slave.pubertyXX < 1) {
			slave.counter.birthsTotal = 0;
		}
		slave.counter.birthsTotal = Math.clamp(slave.counter.birthsTotal, 0, ((slave.actualAge-slave.pubertyAgeXX)*50));
	}
	if (slave.slaveName === "") {
		slave.slaveName = "Nameless";
	}
	if (slave.slaveSurname === "") {
		slave.slaveSurname = 0;
	}

	if ((slave.anus > 2 && slave.skill.anal <= 10) || (slave.anus === 0 && slave.skill.anal > 30)) {
		slave.skill.anal = 15;
	}
	if (slave.vagina < 0) {
		slave.skill.vaginal = 0;
	} else if ((slave.vagina > 2 && slave.skill.vaginal <= 10) || (slave.vagina === 0 && slave.skill.vaginal > 30)) {
		slave.skill.vaginal = 15;
	}

	slave.prestige = Math.clamp(slave.prestige, 0, 3) || 0;
	if (slave.prestige === 0) {
		slave.prestigeDesc = 0;
	}
};

/** Apply starting girl PC career bonus
 * @param {App.Entity.SlaveState} slave
 */
App.StartingGirls.applyCareerBonus = function(slave) {
	function applySexSkillBonus() {
		let _seed = 2;
		if (slave.skill.oral < 60) {
			slave.skill.oral += 20;
			_seed--;
		}
		if ((slave.skill.anal < 60) && ((slave.anus > 0) || (slave.skill.anal <= 10))) {
			slave.skill.anal += 20;
			_seed--;
		}
		if ((_seed > 0) && (slave.skill.vaginal < 60) && (slave.vagina > -1) && ((slave.vagina > 0) || (slave.skill.vaginal <= 10))) {
			slave.skill.vaginal += 20;
		}
	}

	if (V.applyCareerBonus) {
		switch(V.PC.career) {
			case "capitalist":
			case "entrepreneur":
			case "business kid":
				if (slave.skill.whoring < 60) {
					slave.skill.whoring += 20;
				}
				break;
			case "mercenary":
			case "recruit":
			case "child soldier":
				if (slave.devotion > 20) {
					slave.trust += 10;
				} else {
					slave.trust -= 10;
				}
				break;
			case "slaver":
			case "slave overseer":
			case "slave tender":
				slave.devotion += 10;
				break;
			case "medicine":
			case "medical assistant":
			case "nurse":
				slave.boobs += 600;
				slave.boobsImplant += 600;
				slave.boobsImplantType = "normal";
				slave.butt += 2;
				slave.buttImplant += 2;
				slave.buttImplantType = "normal";
				slave.lips += 10;
				slave.lipsImplant += 10;
				slave.waist = -55;
				break;
			case "celebrity":
			case "rising star":
			case "child star":
				if (slave.skill.entertainment < 60) {
					slave.skill.entertainment += 20;
				}
				break;
			case "servant":
			case "handmaiden":
			case "child servant":
				slave.trust += 10;
				slave.devotion += 10;
				break;
			case "gang":
			case "hoodlum":
			case "street urchin":
				improveCondition(slave, 5);
				if (slave.skill.combat < 1) {
					slave.skill.combat += 1;
				}
				break;
			case "BlackHat":
			case "hacker":
			case "script kiddy":
				slave.intelligence += 40;
				if (slave.intelligence > 100) {
					slave.intelligence = 100;
				}
				break;
			case "escort":
			case "prostitute":
			case "child prostitute":
				if (slave.skill.entertainment < 60) {
					slave.skill.entertainment += 20;
				}
				if (slave.skill.whoring < 60) {
					slave.skill.whoring += 20;
				}
				applySexSkillBonus();
				break;
			case "wealth":
			case "trust fund":
			case "rich kid":
				applySexSkillBonus();
				break;
			default:
				slave.devotion += 10;
				if (slave.skill.whoring < 60) {
					slave.skill.whoring += 20;
				}
				if (slave.skill.entertainment < 60) {
					slave.skill.entertainment += 20;
				}
				applySexSkillBonus();
		}
	}
};

/** Randomize things the player doesn't know about the slave
 * @param {App.Entity.SlaveState} slave
 */
App.StartingGirls.randomizeUnknowns = function(slave) {
	if (slave.attrKnown === 0) {
		slave.attrXX = random(0, 100);
		slave.attrXY = random(0, 100);
		slave.energy = random(1, 90);
	}
	if (slave.fetish !== "mindbroken" && slave.fetishKnown === 0) {
		slave.fetishStrength = random(0, 90);
		slave.fetish = either("boobs", "buttslut", "cumslut", "dom", "humiliation", "masochist", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "pregnancy", "sadist", "submissive");
	}
};

/** Generate a pipe-separated list of slaves with a given mother or father
 * @param {string} parent - "mother" or "father"
 * @param {number} id - parent's slave ID
 * @returns {string}
 */
App.StartingGirls.listOfSlavesWithParent = function(parent, id) {
	if (id === 0) {
		return "";
	}
	let slaveNames = [];
	if (V.PC[parent] === id) {
		slaveNames.push("You");
	}
	const slavesWithParent = V.slaves.filter((s) => s[parent] === id);
	slaveNames = slaveNames.concat(slavesWithParent.map((s) => s.slaveName));
	return slaveNames.join(" | ");
};

/** Render the family tree with an uncommitted slave
 * @param {App.Entity.SlaveState} slave
 */
App.StartingGirls.uncommittedFamilyTree = function(slave) {
	let tSlaves = V.slaves.concat([slave]); // returns a new array
	renderFamilyTree(tSlaves, slave.ID);
};

App.StartingGirls.applyPlayerOrigin = function(slave) {
	switch (V.PC.career) {
		case "wealth":
		case "trust fund":
		case "rich kid":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "You bet your body on a sure hand, only to lose. It turns out you could fuck yourself, and not only that, get yourself pregnant.";
				slave.custom.tattoo = "$He has a small tattoo of a losing hand of cards on the nape of $his neck.";
			} else if (slave.mother === -1) {
				slave.origin = "You bet your body on a sure hand, only to lose. Nine months later, your $daughter was born.";
				slave.custom.tattoo = "$He has a small tattoo of a losing hand of cards on the nape of $his neck.";
			} else if (slave.father === -1) {
				slave.origin = "You won a sexual fling with $his mother after winning at cards, a gamble that ultimately burdened you.";
				slave.custom.tattoo = "$He has a small tattoo of a poor hand of cards on the nape of $his neck.";
			} else {
				slave.origin = "You won $him at cards, a memento from your life as one of the idle rich before you became an arcology owner.";
				slave.custom.tattoo = "$He has a small tattoo of a winning hand of cards on the nape of $his neck.";
			}
			break;
		case "capitalist":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "To solidify an investment in hermaphrodite self-fertility, you took part in a successful test trial. Nine months later your $daughter was born.";
			} else if (slave.mother === -1) {
				slave.origin = "Sometimes it pays off to use your body in business deals, and other times you end up burdened with child. $He is the result of the latter.";
			} else if (slave.father === -1) {
				slave.origin = "To seal a business deal, a client asked you to knock her up. $He is the end result of that fling.";
			} else {
				slave.origin = "You acquired $him in the last stages of your career as a successful venture capitalist.";
			}
			slave.custom.tattoo = "$He has a famous corporate logo tattooed on the nape of $his neck.";
			break;
		case "entrepreneur":
		case "business kid":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "To stand a chance in snagging an investment in hermaphrodite self-fertility, you took part in a successful test trial. Nine months later your $daughter was born.";
			} else if (slave.mother === -1) {
				slave.origin = "Sometimes it pays off to use your body in business deals, and other times you end up burdened with child. $He is the result of the latter.";
			} else if (slave.father === -1) {
				slave.origin = "To seal a business deal, a client asked you to knock her up. $He is the end result of that fling.";
			} else {
				slave.origin = "You acquired $him in the last stages of your career as a budding entrepreneur.";
			}
			slave.custom.tattoo = "$He has your business logo tattooed on the nape of $his neck.";
			break;
		case "mercenary":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "Drugs and alcohol can be a potent mix; the night that followed it can sometimes be hard to remember. Needless to say, once your belly began swelling with $him, you had to temporarily switch to a desk job for your mercenary group.";
			} else if (slave.mother === -1) {
				slave.origin = "Drugs and alcohol can be a potent mix; the night that followed it can sometimes be hard to remember. Needless to say, once your belly began swelling with $him, you had to temporarily switch to a desk job for your mercenary group.";
			} else if (slave.father === -1) {
				slave.origin = "A trip to a brothel after a mission resulted in an unexpected surprise years later.";
			} else {
				slave.origin = "You acquired $him in the last stages of your career as a noted private military contractor.";
			}
			slave.custom.tattoo = "$He has a small tattoo of a private military company's coat of arms on the nape of $his neck.";
			break;
		case "recruit":
		case "child soldier":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "Drugs and alcohol can be a potent mix; the night that followed it can sometimes be hard to remember. Needless to say, once your belly began swelling with $him, your chances at further promotion become rather slim.";
			} else if (slave.mother === -1) {
				slave.origin = "Drugs and alcohol can be a potent mix; the night that followed it can sometimes be hard to remember. Needless to say, once your belly began swelling with $him, your chances at further promotion become rather slim.";
			} else if (slave.father === -1) {
				slave.origin = "A trip to a brothel after a mission resulted in an unexpected surprise years later.";
			} else {
				slave.origin = "You acquired $him in the last stages of your career as a soldier for hire.";
			}
			slave.custom.tattoo = "$He has a small tattoo of a private military company's coat of arms on the nape of $his neck.";
			break;
		case "slaver":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "You never thought you would be capable of impregnating yourself, but years of pleasuring yourself with yourself after missions managed to create $him.";
			} else if (slave.mother === -1) {
				slave.origin = "A fresh capture once overpowered you and had his way with you. You kept $him as a painful reminder to never lower your guard again.";
			} else if (slave.father === -1) {
				slave.origin = "Your slaving troop kept several girls as fucktoys; you sired $him in your favorite.";
			} else {
				slave.origin = "You enslaved $him personally during the last stages of your slaving career.";
			}
			slave.custom.tattoo = "$He has your tiny slaving emblem tattooed behind $his left ear.";
			break;
		case "slave overseer":
		case "slave tender":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "You never thought you would be capable of impregnating yourself, but years of pleasuring yourself with yourself to slaves being broken in proved otherwise.";
			} else if (slave.mother === -1) {
				slave.origin = "A fresh capture once overpowered you and had his way with you. You kept $him as a painful reminder to always watch your back.";
			} else if (slave.father === -1) {
				slave.origin = "Members of your slaving group were expected to take part in slave breaking. Sometimes accidents like $him happened. This time it was on you.";
			} else {
				slave.origin = "You got to keep $him as a going away present when you left the slaving group.";
			}
			slave.custom.tattoo = "$He has the tiny slaving emblem of the group you worked for tattooed behind $his left ear.";
			break;
		case "engineer":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "You sired $him in yourself after an arcology owner, impressed by your work, rewarded you with a night you'll never forget.";
			} else if (slave.mother === -1) {
				slave.origin = "You conceived $him after a male arcology owner, impressed by your work, rewarded you with a night you'll never forget.";
			} else if (slave.father === -1) {
				slave.origin = "You sired $him after a female arcology owner, impressed by your work, rewarded you with a night you'll never forget.";
			} else {
				slave.origin = "You received $him as a gift from an arcology owner impressed by your work.";
			}
			slave.custom.tattoo = "$He has the geometric symbol of your old arcology engineering firm laser tattooed into the nape of $his neck.";
			break;
		case "construction":
		case "worksite helper":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "You sired $him in yourself after a string of women rejected your catcalls.";
			} else if (slave.mother === -1) {
				slave.origin = "You conceived $him during a job well done celebration with your coworkers.";
			} else if (slave.father === -1) {
				slave.origin = "A catcall turned sexual romp lead to an unexpected surprise nine months later.";
			} else {
				slave.origin = "You received $him as a gift for all the work you gave the construction firm.";
			}
			slave.custom.tattoo = "$He has the logo of the construction firm you worked with laser tattooed into the nape of $his neck.";
			break;
		case "medicine":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "$He was conceived after a successful experiment in hermaphrodite self-reproduction.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was conceived after a botched birth control experiment early in your career.";
			} else if (slave.father === -1) {
				slave.origin = "$He is the product of an affair with a cute nurse who assisted you in more ways than one.";
			} else {
				slave.origin = "You kept $him after $his owner failed to pay your bill for performing surgery on $him.";
			}
			slave.custom.tattoo = "$He has your personal symbol tattooed on the back of $his neck: it's invisible to the naked eye, but shows up starkly on medical imaging.";
			break;
		case "medical assistant":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "$He was conceived after a successful experiment in hermaphrodite self-reproduction.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was the result of a backfired surrogacy program.";
			} else if (slave.father === -1) {
				slave.origin = "$He is the product of an affair with a cute nurse you worked with.";
			} else {
				slave.origin = "You got to keep $him when $he was given as unwanted payment to the practice.";
			}
			slave.custom.tattoo = "$He has the symbol of the practice you worked at tattooed on the back of $his neck: it's invisible to the naked eye, but shows up starkly on medical imaging.";
			break;
		case "nurse":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "$He was conceived after some self-experimentation in hermaphrodite self-reproduction.";
			} else if (slave.mother === -1) {
				slave.origin = "$He took root in your womb when you decided to play with the IFV tools.";
			} else if (slave.father === -1) {
				slave.origin = "You provided the sperm for $his conception, but the client backed out post-birth so you offered to look after $him.";
			} else {
				slave.origin = "You got to keep $him when $he was given as unwanted payment to the practice.";
			}
			slave.custom.tattoo = "$He has the symbol of the practice you worked at tattooed on the back of $his neck: it's invisible to the naked eye, but shows up starkly on medical imaging.";
			break;
		case "celebrity":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "$He was conceived after a night of partying and a drunken bet. $He nearly killed your career.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was conceived after a night of partying and a torn condom. $He nearly killed your career.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else if (slave.father === -1) {
				slave.origin = "$He was conceived after a night of partying and a torn condom.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else {
				slave.origin = "$He was one of your groupies during your celebrity career.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck. $He got the tattoo when $he was still free.";
			}
			break;
		case "rising star":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "A casting agent told you to go fuck yourself if you wanted the lead role. You complied, but your resulting pregnancy forced you to be an extra.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else if (slave.mother === -1) {
				slave.origin = "A director offered you a lead role in exchange for your body. You complied, but your resulting pregnancy forced you to be an extra.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else if (slave.father === -1) {
				slave.origin = "$He was conceived after a night of partying and a torn condom. As a bonus, the girl you knocked up was no longer in competition with you for roles.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else {
				slave.origin = "$He was one of your groupies during your celebrity career.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck. $He got the tattoo when $he was still free.";
			}
			break;
		case "child star":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "A sleazy casting agent had you fuck yourself to get a major role. You complied, but your resulting pregnancy ruined your chances.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else if (slave.mother === -1) {
				slave.origin = "A sleazy director offered you an important role if you had sex with him. Needless to say, a knocked up young girl doesn't get many roles.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else if (slave.father === -1) {
				slave.origin = "One of your older fans got the chance to meet you. You left her more than she bargained for.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck.";
			} else {
				slave.origin = "$He was a huge fan of yours during your celebrity career.";
				slave.custom.tattoo = "$He has your signature, surrounded by hearts, tattooed on the back of $his neck. $He got the tattoo when $he was still free.";
			}
			break;
		case "escort":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "A client paid you a large sum of credits to prove you could literally fuck yourself. $He is the result of that lucrative night.";
				slave.custom.tattoo = "$He has your custom emblem tattooed on $his left breast.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was the result of unprotected sex with a client. He paid you quite well to enjoy your body as you grew heavy with his child.";
				slave.custom.tattoo = "$He has the number of times $his father came in you while you were pregnant with $him tattooed down $his back.";
			} else if (slave.father === -1) {
				slave.origin = "$He was the result of unprotected sex with a client. $His mother tracked you down years after $his birth to force $him upon you.";
				slave.custom.tattoo = "$He has your name angrily tattooed on $his right shoulder.";
			} else {
				slave.origin = "$He was a fellow escort you were popular with.";
				slave.custom.tattoo = "$He has your custom emblem tattooed on $his left breast. $He got the tattoo after starring in a porno with you.";
			}
			if (slave.preg > 0) {
				if (slave.pregSource !== -1) {
					slave.pregSource = -5;
				}
			}
			break;
		case "prostitute":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "A customer paid you a large sum of credits to prove you could literally fuck yourself. $He is the result of that night.";
				slave.custom.tattoo = "$He has your ID number tattooed on $his right breast.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was the result of unprotected sex with a customer. Birth control was completely optional at the brothel.";
				slave.custom.tattoo = "$He has your ID number tattooed on $his right breast.";
			} else if (slave.father === -1) {
				slave.origin = "$He was the result of unprotected sex with a customer. $His mother tracked you down years after $his birth to force $him upon you.";
				slave.custom.tattoo = "$He has your name angrily tattooed on $his right shoulder.";
			} else {
				slave.origin = "$He was a fellow prostitute you often bunked with.";
				slave.custom.tattoo = "$He has $his ID number tattooed on $his left breast.";
			}
			if (slave.preg > 0) {
				if (slave.pregSource !== -1) {
					slave.pregSource = -5;
				}
			}
			break;
		case "child prostitute":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "A customer paid you a large sum of credits to prove you could literally fuck yourself. $He is the result of that night much to everybody's surprise.";
				slave.custom.tattoo = "$He has your ID number tattooed on $his right breast.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was the result of unprotected sex with a customer. Turns out you weren't too young to get pregnant.";
				slave.custom.tattoo = "$He has your ID number tattooed on $his right breast.";
			} else if (slave.father === -1) {
				slave.origin = "$He was the result of unprotected sex with a customer. $His mother abandoned your child on the brothel's doorstep.";
				slave.custom.tattoo = "$He has your ID number tattooed on $his right breast.";
			} else {
				if (slave.actualAge >= V.PC.actualAge + 10) {
					slave.origin = "$He was a fellow prostitute who was like a parent to you.";
				} else {
					slave.origin = "$He was a fellow underage prostitute you often played with.";
				}
				slave.custom.tattoo = "$He has $his ID number tattooed on $his left breast.";
			}
			if (slave.preg > 0) {
				if (slave.pregSource !== -1) {
					slave.pregSource = -5;
				}
			}
			break;
		case "gang":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "$He was the result of a night of hard drugs and unprotected sex after a big score. It took quite a bit of alcohol to come to terms with drunkenly knocking yourself up.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was the result of a night of hard drugs and unprotected sex after a big score.";
			} else if (slave.father === -1) {
				slave.origin = "$He was born from one of your sex toys you knocked up.";
			} else {
				slave.origin = "You captured $him during your transition to the arcology";
			}
			slave.custom.tattoo = "$He has your former gang's sign tattooed on $his neck.";
			break;
		case "hoodlum":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "Getting drunk and taking bets on what you can or cannot stick in your holes is not something you what to explain to a resulting child.";
			} else if (slave.mother === -1) {
				slave.origin = "It wasn't uncommon to have to trade sex for favors, and in $his case, you ended up with more than you bargained for.";
			} else if (slave.father === -1) {
				slave.origin = "Given all the casual unprotected sex, it's not really a surprise you're a daddy.";
			} else {
				slave.origin = "You took $him from the gang during your transition to the arcology";
			}
			slave.custom.tattoo = "$He has the gang's sign that you rolled with tattooed on $his neck.";
			break;
		case "street urchin":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "In order to gain any favors from the gang, you often had to appease their demands. They had quite the laugh when they managed to get you to knock yourself up for them.";
			} else if (slave.mother === -1) {
				slave.origin = "It wasn't uncommon to pass time fucking in back alleys, and without any access to protection, you eventually found yourself with child.";
			} else if (slave.father === -1) {
				slave.origin = "It wasn't uncommon to pass time fucking in back alleys, but without any access to protection, pregnancies happened.";
			} else {
				slave.origin = "You took $him with you instead of leaving $him on the streets.";
			}
			slave.custom.tattoo = "$He has the gang's sign that you associated with tattooed on $his neck.";
			break;
		case "servant":
		case "handmaiden":
		case "child servant":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "Your late Master took pleasure in using his servants in creative ways. He inseminated you with your own sperm, and nine months later, your $daughter was born.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was another of your late Master's servants. $He spent nine months in your womb, courtesy of your Master.";
			} else if (slave.father === -1) {
				slave.origin = "$He was another of your late Master's servants. Your Master permitted you to knock up $his mother.";
			} else if (V.PC.vagina !== -1) {
				slave.origin = "$He was another of your late Master's servants. $He helped you give birth to his child.";
			} else {
				slave.origin = "$He was another of your late Master's servants.";
			}
			slave.custom.tattoo = "$He has your Master's brand on $his left breast.";
			if (slave.preg > 0) {
				if (slave.pregSource !== -1) {
					slave.pregSource = -3;
				}
			}
			break;
		case "BlackHat":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "$He was the result of a night of hard celebration after a big score under the glow of monitors and the calming hum of 750 RPM fans. It took quite a bit of alcohol to come to terms with drunkenly knocking yourself up.";
			} else if (slave.mother === -1) {
				slave.origin = "$He was the result of an intruder brute forcing your firewall, overloading your pleasure sensors, and allowing a corrupted packet to slip by. With a quick wipe of your RAM and cache with some powerful liquor, you have no idea who planted $him in your womb.";
			} else if (slave.father === -1) {
				slave.origin = "$He was born out of a trade for secure data access. Nine months later, your $daughter was born.";
			} else {
				slave.origin = "$He was a case officer you captured after going dark.";
			}
			slave.custom.tattoo = "$He has your former digital calling card tattooed on $his neck.";
			break;
		case "hacker":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "You got the idea of fucking yourself after watching some private videos you acquired. It took quite a bit of alcohol to come to terms with drunkenly knocking yourself up.";
			} else if (slave.mother === -1) {
				slave.origin = "What was intended to be a lucrative scam resulted in you bumping uglies with the bigger fish in the pond. $He is the result of that trist.";
			} else if (slave.father === -1) {
				slave.origin = "A little data manipulation and suddenly you were the sperm donor in place of $his intended father. Years later $he managed to find $his way to you.";
			} else {
				slave.origin = "$He was someone you wanted to keep quiet after going dark.";
			}
			slave.custom.tattoo = "$He has your encoded online handle tattooed on $his neck.";
			break;
		case "script kiddy":
			if (slave.mother === -1 && slave.father === -1) {
				slave.origin = "Just because you saw it on the internet doesn't mean you should try it. You did and now you are both a proud mother and father.";
			} else if (slave.mother === -1) {
				slave.origin = "You got a little sloppy with covering your tracks allowing a slighted rival to track you down. The resulting confrontation wasn't all that unpleasant, but the following couple years were hell.";
			} else if (slave.father === -1) {
				slave.origin = "You wanted to see how easily you could trick some girl into thinking you were famous. You ended up with a $daughter from the resulting sex.";
			} else {
				slave.origin = "$He was an unfortunate sap you tricked into enslaving themselves.";
			}
			slave.custom.tattoo = "$He has your online handle tattooed on $his neck.";
			break;
		default:
			slave.origin = "You won $him at cards, a memento from your life as one of the idle rich before you became an arcology owner.";
			slave.custom.tattoo = "$He has the silhouette of an arcology tattooed on the nape of $his neck.";
	}
	if (slave.fetish === "mindbroken") {
		if (!isAmputee(slave)) {
			slave.origin = "You brought $him into the arcology mindbroken, little more than a walking collection of fuckable holes.";
		} else {
			slave.origin = "You brought $him into the arcology mindbroken, little more than a human onahole.";
		}
	}
};

App.StartingGirls.physical = function(slave) {
	const el = new DocumentFragment();
	const {he} = getPronouns(slave);
	const options = new App.UI.OptionsGroup();
	let option;

	options.addOption("Condition", "condition", slave.health)
		.addValueList([["Unhealthy", -40], ["Healthy", 0], ["Very healthy", 40], ["Extremely healthy", 80]]);

	options.addOption(`Height: ${heightToEitherUnit(slave.height)}`, "height", slave).showTextBox({unit: "cm"})
		.addRange(145, 150, "<", "Petite")
		.addRange(155, 160, "<", "Short")
		.addRange(165, 170, "<", "Average")
		.addRange(180, 185, "<", "Tall")
		.addRange(190, 185, ">=", "Very tall");
	option = options.addOption(`Average height for a ${slave.actualAge} year old """is ${heightToEitherUnit(Math.round(Height.mean(slave)))}"""`)
		.customButton(
			"Make average",
			() => resyncSlaveHight(slave),
			""
		);
	if (V.cheatMode === 1) {
		option.customButton(
			"Make dwarf",
			() => slave.height = Height.random(slave, {limitMult: [-4, -1], spread: 0.15}),
			""
		)
			.customButton(
				"Make giant",
				() => slave.height = Height.random(slave, {limitMult: [3, 10], spread: 0.15}),
				""
			);
	}

	options.addOption("Weight", "weight", slave)
		.addRange(-100, -95, "<", "Emaciated")
		.addRange(-50, -30, "<", "Skinny")
		.addRange(-20, -10, "<", "Thin")
		.addRange(0, 10, "<", "Average")
		.addRange(20, 30, "<", "Plush")
		.addRange(50, 95, "<", "Chubby")
		.addRange(100, 130, "<", "Fat")
		.addRange(140, 160, "<", "Obese")
		.addRange(180, 190, "<", "Super obese")
		.addRange(200, 190, ">=", "Dangerously obese");

	options.addOption("Muscles", "muscles", slave)
		.addRange(-100, -96, "<", "Frail")
		.addRange(-66, -51, "<", "Very weak")
		.addRange(-41, -6, "<", "Weak")
		.addRange(0, 5, "<", "Normal")
		.addRange(20, 30, "<", "Toned")
		.addRange(40, 50, "<", "Well built")
		.addRange(65, 95, "<", "Quite muscular")
		.addRange(100, 95, ">=", "Ripped");

	options.addOption("Waist", "waist", slave)
		.addRange(-100, -95, "<", "	Absurd")
		.addRange(-55, -40, "<", "Hourglass")
		.addRange(-25, -15, "<", "Feminine")
		.addRange(0, 10, "<", "Average")
		.addRange(15, 40, "<", "Unattractive")
		.addRange(55, 95, "<", "Ugly")
		.addRange(100, 10, ">=", "Masculine");

	option = options.addOption("Facial appearance", "faceShape", slave)
		.addValue("Normal", "normal");
	if (V.seeDicks !== 0) {
		option.addValue("Masculine", "masculine");
	}
	option.addValueList([["Androgynous", "androgynous"], ["Cute", "cute"], ["Sensual", "sensual"], ["Exotic", "exotic"]]);

	options.addOption("Facial attractiveness", "face", slave)
		.addRange(-100, -95, "<", "Very ugly")
		.addRange(-55, -40, "<", "Ugly")
		.addRange(-15, -10, "<", "Unattractive")
		.addRange(0, 10, "<", "Average")
		.addRange(15, 40, "<", "Attractive")
		.addRange(55, 95, "<", "Beautiful")
		.addRange(100, 95, ">=", "Very beautiful");

	option = options.addOption("Lips", "lips", slave)
		.addRange(5, 10, "<", "Thin")
		.addRange(15, 20, "<", "Normal")
		.addRange(25, 40, "<", "Pretty")
		.addRange(55, 70, "<", "Plush");
	if (V.seeExtreme === 1) {
		option.addRange(85, 95, "<", "Huge")
			.addRange(100, 95, ">=", "Facepussy");
	} else {
		option.addRange(85, 70, ">=", "Huge");
	}

	options.addOption("Voice", "voice", slave)
		.addValueList([["Mute", 0], ["Deep", 1], ["Normal", 2], ["High", 3]]);

	if (slave.voice !== 0) {
		options.addOption(V.language, "accent", slave)
			.addValueList([
				["Unaccented", 0],
				[`Pretty ${aNational(slave.nationality)} accent`, 1],
				[`Thick ${aNational(slave.nationality)} accent`, 2],
				["Not fluent", 3]
			]);
	}

	option = options.addOption("Teeth", "teeth", slave)
		.addValueList([
			["Crooked", "crooked"],
			["Gapped", "gapped"],
			["Braces", "straightening braces"]
		]);
	if (slave.physicalAge >= 12) {
		if (slave.teeth === "baby" || slave.teeth === "mixed") {
			slave.teeth = "normal";
		}
		option.addValue("Straight", "normal");
	} else if (slave.physicalAge >= 6) {
		if (slave.teeth === "baby" || slave.teeth === "normal" || slave.teeth === "") {
			slave.teeth = "mixed";
		}
		option.addValue("Mixed adult & child", "mixed");
	} else {
		if (slave.teeth === "mixed" || slave.teeth === "normal" || slave.teeth === "") {
			slave.teeth = "mixed";
		}
		option.addValue("Baby", "baby");
	}

	options.addOption("Breasts", "boobs", slave).showTextBox({unit: "CCs"})
		.addRange(200, 200, "<=", "Flat (AA-cup)")
		.addRange(300, 300, "<=", "Small (A-cup)")
		.addRange(400, 400, "<=", "Medium (B-cup)")
		.addRange(500, 500, "<=", "Healthy (C-cup)")
		.addRange(800, 800, "<=", "Large (DD-cup)")
		.addRange(1200, 1200, "<=", "Very Large (G-cup)")
		.addRange(2050, 2050, "<=", "Huge (K-cup)")
		.addRange(3950, 3950, "<=", "Massive (Q-cup)")
		.addRange(6000, 6000, "<=", "Monstrous")
		.addRange(8000, 6000, ">", "Science Experiment");

	options.addOption("Natural shape", "boobShape", slave)
		.addValueList([
			["Normal", "normal"],
			["Perky", "perky"],
			["Torpedo-shaped", "torpedo-shaped"],
			["Wide-set", "wide-set"],
			["Downward-facing", "downward-facing"],
			["Saggy", "saggy"]
		]);

	options.addOption("Lactation", "lactation", slave)
		.addValue("Artificial", 2, () => slave.lactationDuration = 2)
		.addValue("Natural", 1, () => slave.lactationDuration = 2)
		.addValue("None", 0);

	options.addOption("Nipples", "nipples", slave)
		.addValueList([["Tiny", "tiny"], ["Cute", "cute"], ["Puffy", "puffy"], ["Partially Inverted", "partially inverted"], ["Inverted", "inverted"], ["Huge", "huge"]]);

	options.addOption("Areolae", "areolae", slave)
		.addValueList([["Normal", 0], ["Large", 1], ["Wide", 2], ["Huge", 3], ["Massive", 4]]);

	options.addOption("Shoulders", "shoulders", slave)
		.addValueList([["Very narrow", -2], ["Narrow", -1], ["Feminine", 0], ["Broad", 1], ["Very broad", 2]]);

	options.addOption("Hips", "hips", slave)
		.addValueList([["Very narrow", -2], ["Narrow", -1], ["Normal", 0], ["Broad", 1], ["Very broad", 2]]);

	options.addOption("Butt", "butt", slave)
		.addValueList([["Flat", 0], ["Small", 1], ["Plump", 2], ["Big", 3], ["Huge", 4], ["Enormous", 5], ["Gigantic", 6], ["Massive", 7]]);

	options.addOption("Anus", "anus", slave)
		.addValueList([["Virgin", 0], ["Normal", 1], ["Veteran", 2], ["Gaping", 3]]);

	if (slave.anus > 0) {
		let comment;
		if (slave.analArea <= slave.anus) {
			comment = "Recently stretched to current size.";
		} else if (slave.analArea - slave.anus === 1) {
			comment = "Used to current size.";
		} else {
			comment = "Very broad.";
		}
		options.addOption("External anus appearance", "anus", slave)
			.addValueList([
				["Recently stretched", slave.analArea = slave.anus],
				["Used to current size", slave.analArea = slave.anus+1],
				["Very broad", slave.analArea = slave.anus+2],
			]).addComment(comment);
	}

	options.addOption("Vagina", "vagina", slave)
		.addValue("No vagina", -1, () => {
			slave.preg = 0;
			WombFlush(slave);
			slave.belly = 0;
			slave.bellyPreg = 0;
			slave.pubertyXX = 0;
			slave.pubertyAgeXX = V.fertilityAge;
			slave.ovaries= 0;
		})
		.addValue("Virgin", 0, () => {
			slave.preg = -1;
			slave.belly = 0;
			slave.bellyPreg = 0;
			slave.ovaries = 1;
		})
		.addValue("Normal", 1, () => {
			slave.preg = -1;
			slave.belly = 0;
			slave.bellyPreg = 0;
			slave.ovaries = 1;
		})
		.addValue("Veteran", 2, () => {
			slave.preg = -1;
			slave.belly = 0;
			slave.bellyPreg = 0;
			slave.ovaries = 1;
		})
		.addValue("Gaping", 3, () => {
			slave.preg = -1;
			slave.belly = 0;
			slave.bellyPreg = 0;
			slave.ovaries = 1;
		});

	if (slave.vagina > -1) {
		if (slave.dick === 0) {
			options.addOption("Clit", "clit", slave)
				.addValueList([["Normal", 0], ["Large", 1], ["Huge", 2]]);
		}

		options.addOption("Labia", "labia", slave)
			.addValueList([["Normal", 0], ["Large", 1], ["Huge", 2], ["Huge Dangling", 3]]);

		options.addOption("Vaginal wetness", "vaginaLube", slave)
			.addValueList([["Dry", 0], ["Normal", 1], ["Excessive", 2]]);

		if (V.seePreg !== 0) {
			/* This is only shown if slave has vagina */
			options.addOption("Puberty", "pubertyXX", slave)
				.addValue("Prepubescent", 0, () => {
					slave.pubertyAgeXX = V.fertilityAge;
					slave.belly = 0;
					slave.bellyPreg = 0;
					WombFlush(slave);
				}).addValue("Postpubescent", 1);

			options.addOption("Age of puberty", "pubertyAgeXX", slave).showTextBox();

			if (slave.pubertyXX === 1) {
				option = options.addOption("Pregnancy", "preg", slave);
				if (V.seeHyperPreg === 1 && V.cheatMode === 1) {
					option.addValue("Bursting at the seams", 43, () => {
						slave.pregType = 150;
						slave.pregWeek = 43;
						slave.pregKnown = 1;
						slave.belly = 2700000;
						slave.bellyPreg = 2700000;
						slave.pubertyXX = 1;
					});
					if (slave.preg === 43) {
						option.addComment("Extreme hyper pregnancy!");
					}
				}
				option.addValue("Completely Filled", 42, () => {
					slave.pregType = 8;
					slave.pregWeek = 42;
					slave.pregKnown = 1;
					slave.belly = 120000;
					slave.bellyPreg = 120000;
					slave.pubertyXX = 1;
				}).addValue("Ready to drop", 40, () => {
					slave.pregType = 1;
					slave.pregWeek = 40;
					slave.pregKnown = 1;
					slave.belly = 15000;
					slave.bellyPreg = 15000;
					slave.pubertyXX = 1;
				}).addValue("Advanced", 34, () => {
					slave.pregType = 1;
					slave.pregWeek = 34;
					slave.pregKnown = 1;
					slave.belly = 10000;
					slave.bellyPreg = 10000;
					slave.pubertyXX = 1;
				}).addValue("Showing", 27, () => {
					slave.pregType = 1;
					slave.pregWeek = 27;
					slave.pregKnown = 1;
					slave.belly = 5000;
					slave.bellyPreg = 5000;
					slave.pubertyXX = 1;
				}).addValue("Early", 12, () => {
					slave.pregType = 1;
					slave.pregWeek = 12;
					slave.pregKnown = 1;
					slave.belly = 100;
					slave.bellyPreg = 100;
					slave.pubertyXX = 1;
				}).addValue("None", 0, () => {
					slave.pregType = 0;
					slave.belly = 0;
					slave.bellyPreg = 0;
					slave.pregSource = 0;
					slave.pregWeek = 0;
					slave.pregKnown = 0;
				}).addValue("Contraceptives", -1, () => {
					slave.pregType = 0;
					slave.belly = 0;
					slave.bellyPreg = 0;
					slave.pregSource = 0;
					slave.pregWeek = 0;
					slave.pregKnown = 0;
				}).addValue("Barren", -2, () => {
					slave.pregType = 0;
					slave.belly = 0;
					slave.bellyPreg = 0;
					slave.pregSource = 0;
					slave.pregWeek = 0;
					slave.pregKnown = 0;
				});
				options.addOption("Births", "birthsTotal", slave.counter).showTextBox().addComment(`How many times ${he} has already given birth, not necessarily while owned by you.`);
			}

			if (V.PC.dick > 0 && slave.preg > 0) {
				options.addOption("Father of child", "pregSource", slave)
					.addValueList([["My child", -1], ["Not me", 0]]);
			}
		}
	}

	if (V.seeDicks !== 0 || V.makeDicks === 1) {
		options.addOption("Penis", "dick", slave)
			.addValue("None", 0, () => {
				slave.balls = 0;
				slave.pubertyXY = 0;
				slave.pubertyAgeXY = V.potencyAge;
			})
			.addValue("Tiny", 1, () => slave.clit = 0)
			.addValue("Small", 2, () => slave.clit = 0)
			.addValue("Normal", 3, () => slave.clit = 0)
			.addValue("Large", 4, () => slave.clit = 0)
			.addValue("Massive", 5, () => slave.clit = 0);

		if (slave.dick > 0) {
			option = options.addOption("Foreskin", "foreskin", slave);
			if (V.seeCircumcision === 1) {
				option.addValue("Circumcised", 0);
			} else if (slave.foreskin === 0) {
				slave.foreskin = 3;
			}
			option.addValueList([["Tiny", 1], ["Small", 2], ["Normal", 3], ["Large", 4], ["Massive", 5]]);
		}

		options.addOption("Testicles", "balls", slave)
			.addValue("None", 0, () => {
				slave.pubertyXY = 0;
				slave.pubertyAgeXY = V.potencyAge;
				slave.scrotum = 0;
			}).addValueList([["Vestigial", 1], ["Small", 2], ["Normal", 3], ["Large", 4], ["Massive", 5]]);

		options.addOption("Age of Male Puberty", "pubertyAgeXY", slave).showTextBox();

		if (slave.balls > 0) {
			options.addOption("Ballsack", "scrotum", slave)
				.addValueList([["None", 0], ["Tiny", 1], ["Small", 2], ["Normal", 3], ["Large", 4], ["Massive", 5]]);

			options.addOption("Male Puberty", "pubertyXY", slave)
				.addValue("Prepubescent", 0, () => slave.pubertyAgeXY = V.potencyAge)
				.addValue("Postpubescent", 1);
		}
	}

	options.addOption("Prostate", "prostate", slave)
		.addValueList([
			["No prostate", 0],
			["Has a prostate", 1]
		]);

	const optionLeft = options.addOption("Left eye", "vision", slave.eye.left);
	const optionRight = options.addOption("Right eye", "vision", slave.eye.right);
	optionLeft.addValueList([["Normal", 2], ["Nearsighted", 1]]);
	optionRight.addValueList([["Normal", 2], ["Nearsighted", 1]]);
	if (V.seeExtreme === 1) {
		optionLeft.addValue("Blind", 0);
		optionRight.addValue("Blind", 0);
	} else {
		if (slave.eye.left.vision === 0) {
			slave.eye.left.vision = 2;
		}
		if (slave.eye.right.vision === 0) {
			slave.eye.right.vision = 2;
		}
	}
	option = options.addOption("Natural eye color", "origColor", slave.eye);
	for (const color of App.Medicine.Modification.eyeColor.map(color => color.value)) {
		option.addValue(capFirstChar(color), color);
	}
	option.pulldown();

	option = options.addOption("Hearing", "hears", slave);
	option.addValueList([["Normal", 0], ["Hard of hearing", -1]]);
	if (V.seeExtreme === 1) {
		option.addValue("Deaf", -2);
	} else if (slave.hears === 0) {
		slave.hears = 2;
	}

	if (V.seeExtreme === 1) {
		options.addOption("Smell ability", "smells", slave)
			.addValueList([["Normal", 0], ["None", -1]]);

		options.addOption("Taste ability", "tastes", slave)
			.addValueList([["Normal", 0], ["None", -1]]);

		State.temporary.LA = hasLeftArm(slave);
		options.addOption("Left arm", "LA", State.temporary)
			.addValue("Healthy", true, () => slave.arm.left = new App.Entity.LimbState())
			.addValue("Amputated", false, () => slave.arm.left = null);

		State.temporary.RA = hasRightArm(slave);
		options.addOption("Right arm", "RA", State.temporary)
			.addValue("Healthy", true, () => slave.arm.right = new App.Entity.LimbState())
			.addValue("Amputated", false, () => slave.arm.right = null);

		State.temporary.LL = hasLeftLeg(slave);
		options.addOption("Left leg", "LL", State.temporary)
			.addValue("Healthy", true, () => slave.leg.left = new App.Entity.LimbState())
			.addValue("Amputated", false, () => slave.leg.left = null);

		State.temporary.RL = hasRightLeg(slave);
		options.addOption("Right leg", "RL", State.temporary)
			.addValue("Healthy", true, () => slave.leg.right = new App.Entity.LimbState())
			.addValue("Amputated", false, () => slave.leg.right = null);
	}

	el.append(options.render());
	return el;
};

App.StartingGirls.profile = function(slave) {
	const el = new DocumentFragment();
	let options = new App.UI.OptionsGroup();
	let option;
	const {His} = getPronouns(slave);

	options.addOption("Birth name", "birthName", slave).showTextBox();
	options.addOption("Slave name", "slaveName", slave).showTextBox();
	options.addOption("Birth surname", "birthSurname", slave).showTextBox();
	options.addOption("Slave surname", "slaveSurname", slave).showTextBox();

	option = options.addOption("Career", "career", slave).showTextBox();
	let careers;
	let text;
	if (V.AgePenalty === 1) {
		if (slave.actualAge < 16) {
			text = "Very young careers";
			careers = App.Data.Careers.General.veryYoung;
		} else if (slave.actualAge <= 24) {
			text = "Young careers";
			careers = App.Utils.alphabetizeIterable(App.Data.Careers.General.young);
		} else if (slave.intelligenceImplant >= 15) {
			text = "Educated careers";
			careers = App.Utils.alphabetizeIterable(App.Data.Careers.General.educated);
		} else {
			text = "Uneducated careers";
			careers = App.Utils.alphabetizeIterable(App.Data.Careers.General.uneducated);
		}
	} else {
		if (slave.actualAge < 16) {
			text = "Very young careers";
			careers = App.Utils.alphabetizeIterable(App.Data.Careers.General.veryYoung);
		} else if (slave.intelligenceImplant >= 15) {
			text = "Educated careers";
			careers = App.Utils.alphabetizeIterable(App.Data.Careers.General.educated);
		} else if (slave.actualAge <= 24) {
			text = "Young careers";
			careers = App.Utils.alphabetizeIterable(App.Data.Careers.General.young);
		} else {
			text = "Uneducated careers";
			careers = App.Utils.alphabetizeIterable(App.Data.Careers.General.uneducated);
		}
	}
	for (const career of careers) {
		option.addValue(capFirstChar(career), career);
	}
	option.addComment(text).pulldown();

	options.addOption("Legal status", "indenture", slave)
		.addValue("Slave", -1, () => slave.indentureRestrictions = 0)
		.addRange(52, 0, ">=", "Indentured Servant");
	if (slave.indenture > -1) {
		options.addOption("Remaining weeks", "indenture", slave).showTextBox();

		options.addOption("Indenture restrictions", "indentureRestrictions", slave)
			.addValueList([["None", 0], ["Protective", 1], ["Restrictive", 2]]);
	}

	options.addOption("Age", "actualAge", slave).showTextBox()
		.customButton("Resync characteristics to age", () => resyncSlaveToAge(slave), "")
		.customButton("Resync only height to age", () => slave.height = Height.random(slave), "")
		.addComment("It is recommended to resync if you change age significantly");

	options.addOption("Birth week", "birthWeek", slave).showTextBox();

	options.addOption("Genes", "genes", slave)
		.addValue("XX (Female)", "XX", () => {
			slave.dick = 0;
			slave.balls = 0;
			slave.clit = 0;
			slave.pubertyXY = 0;
			slave.pubertyAgeXY = V.potencyAge;
			slave.pubertyXX = (slave.pubertyAgeXX < slave.actualAge ? 1 : 0);
			slave.vagina = Math.max(0, slave.vagina);
			slave.boobs = Math.max(500, slave.boobs);
			slave.balls = 0;
			slave.scrotum = 0;
			slave.prostate = 0;
			slave.shoulders = either(-2, -1, 0);
			slave.hips = either(-2, -1, 0);
		}).addValue("XY (Male)", "XY", () => {
			slave.dick = 3;
			slave.vagina = -1;
			WombFlush(slave);
			slave.belly = 0;
			slave.bellyPreg = 0;
			slave.pubertyXY = (slave.pubertyAgeXY < slave.actualAge ? 1 : 0);
			slave.pubertyXX = 0;
			slave.pubertyAgeXX = V.fertilityAge;
			slave.ovaries = 0;
			slave.boobs = 0;
			slave.balls = 3;
			slave.scrotum = 3;
			slave.prostate = 1;
			slave.shoulders = either(0, 1, 2);
			slave.hips = either(0, 1, 2);
		});

	option = options.addOption("Prestige", "prestige", slave)
		.addValueList([
			["None", 0],
			["Locally known", 1],
			["Regionally famous", 2],
			["World renowned", 3]
		]);
	if (slave.prestige > 0) {
		const r = [];
		r.push("Starting slaves incur an extreme cost penalty for prestige. This slave's");
		if (slave.actualAge >= 25) {
			if (slave.actualAge > 35) {
				r.push("advanced");
			}
			r.push("age decreases the penalty.");
		} else {
			r.push("young age requires paying the full penalty.");
		}
		option.addComment(`<span class="warning">${r.join(" ")}</span>`);
	}

	options.addOption(`${His} nationality is`, "nationality", slave).showTextBox()
		.addValueList(App.Data.misc.baseNationalities)
		.pulldown();


	if (V.seeRace === 1) {
		options.addOption(`${His} ethnicity is`, "race", slave).showTextBox().pulldown()
			.addValueList([["White", "white"], ["Asian", "asian"], ["Latina", "latina"], ["Middle Eastern", "middle eastern"],
				["Black", "black"], ["Semitic", "semitic"], ["Southern European", "southern european"], ["Indo-Aryan", "indo-aryan"],
				["Amerindian", "amerindian"], ["Pacific Islander", "pacific islander"], ["Malay", "malay"], ["Mixed Race", "mixed race"]]);
	}

	el.append(options.render());
	App.UI.DOM.appendNewElement("h3", el, "Optional customizations");
	options = new App.UI.OptionsGroup();

	options.addOption("Origin story", "origin", slave).showTextBox({large: true}).addComment("Use complete, capitalized and punctuated sentences.");

	options.addOption("Origin override", "originOverride", V)
		.addValue("Enable", 1).on()
		.addValue("Disable", 0).off()
		.addComment("Prevent Starting Girls from overwriting custom origin and tattoo with its defaults.");

	if (slave.prestige) {
		options.addOption("Prestige description", "prestigeDesc", slave).showTextBox().addComment("Use complete, capitalized and punctuated sentences.");
	}
	options.addOption("Description", "desc", slave.custom).showTextBox().addComment("Use complete, capitalized and punctuated sentences.");
	options.addOption("Label", "label", slave.custom).showTextBox().addComment("Use a short phrase");


	el.append(options.render());
	return el;
};

App.StartingGirls.mental = function(slave) {
	const el = new DocumentFragment();
	const options = new App.UI.OptionsGroup();
	let option;
	let r;

	options.addOption("Intelligence", "intelligence", slave)
		.addValueList([["Moronic", -100], ["Very stupid", -60], ["Stupid", -30], ["Average", 0], ["Smart", 30], ["Very smart", 60], ["Brilliant", 100]]);

	options.addOption("Education", "intelligenceImplant", slave)
		.addValueList([["Uneducated", 0], ["Educated", 15], ["Well educated", 30]]);

	option = options.addOption("Devotion", "devotion", slave).showTextBox()
		.addRange(-100, -95, "<", "Utterly hateful")
		.addRange(-70, -50, "<", "Hateful")
		.addRange(-35, -20, "<", "Resistant")
		.addRange(0, 20, "<", "Ambivalent")
		.addRange(35, 50, "<", "Accepting")
		.addRange(70, 95, "<", "Devoted")
		.addRange(100, 95, ">=", "Worshipful");
	if (slave.devotion > 20) {
		r = [];
		r.push("Starting slaves incur");
		if (slave.devotion > 50) {
			r.push("severe cost penalty at very high");
		} else {
			r.push("an additional cost penalty at high");
		}
		r.push("levels of devotion. This slave's");
		if (slave.actualAge >= 25) {
			if (slave.actualAge > 35) {
				r.push("advanced");
			}
			r.push("age decreases the penalty.");
		} else {
			r.push("young age requires paying the full penalty.");
		}
		option.addComment(`<span class="warning">${r.join(" ")}</span>`);
	}

	options.addOption("Trust", "trust", slave).showTextBox()
		.addRange(-100, -95, "<", "Abjectly terrified")
		.addRange(-70, -50, "<", "Terrified")
		.addRange(-35, -20, "<", "Frightened")
		.addRange(0, 20, "<", "Fearful")
		.addRange(35, 50, "<", "Careful")
		.addRange(70, 95, "<", "Trusting")
		.addRange(100, 95, ">=", "Absolute trust");



	if (slave.fetishKnown === 0) {
		options.addOption("Fetish", "fetishKnown", slave)
			.addValueList([["Unknown", 0], ["Known", 1]]);
	} else {
		option = options.addOption("Fetish", "fetish", slave)
			.addValue("Unknown", "", () => {
				slave.fetish = either("boobs", "buttslut", "cumslut", "dom", "humiliation", "masochist", "pregnancy", "sadist",
					"submissive", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none");
				slave.fetishKnown = 0;
			}).addValueList([["None", "none"], ["Sub", "submissive"], ["Dom", "dom"], ["Cumslut", "cumslut"], ["Humiliation", "humiliation"],
				["Buttslut", "buttslut"], ["Breasts", "boobs"], ["Pregnancy", "pregnancy"], ["Sadism", "sadist"], ["Masochism", "masochist"]]);
		if (V.seeExtreme === 1) {
			option.addValue("Mindbroken", "mindbroken", () => {
				slave.fetishStrength = 10;
				slave.sexualFlaw = "none";
				slave.sexualQuirk = "none";
				slave.behavioralFlaw = "none";
				slave.behavioralQuirk = "none";
			});
		}

		if (slave.fetish !== "none" && slave.fetish !== "mindbroken") {
			options.addOption("Fetish strength", "fetishStrength", slave)
				.addRange(15, 30, "<=", "Very Low")
				.addRange(45, 60, "<=", "Low")
				.addRange(75, 85, "<=", "Normal")
				.addRange(90, 95, "<=", "High")
				.addRange(100, 95, ">", "Extremely High");
		}
	}

	options.addOption("Sexuality", "attrKnown", slave)
		.addValue("Known", 1, () => {
			slave.attrXX = random(0, 100);
			slave.attrXY = random(0, 100);
			slave.energy = random(1, 90);
		}).on()
		.addValue("Unknown", 0).off();
	if (slave.attrKnown === 1) {
		options.addOption("Attraction to men", "attrXY", slave)
			.addRange(0, 5, "<=", "Disgusted").off()
			.addRange(10, 15, "<=", "Turned off").off()
			.addRange(25, 35, "<=", "Not attracted").off()
			.addRange(50, 65, "<=", "Indifferent").neutral()
			.addRange(75, 85, "<=", "Attracted").on()
			.addRange(90, 95, "<=", "Aroused").on()
			.addRange(100, 95, ">", "Passionate").on();
		options.addOption("Attraction to women", "attrXX", slave)
			.addRange(0, 5, "<=", "Disgusted").off()
			.addRange(10, 15, "<=", "Turned off").off()
			.addRange(25, 35, "<=", "Not attracted").off()
			.addRange(50, 65, "<=", "Indifferent").neutral()
			.addRange(75, 85, "<=", "Attracted").on()
			.addRange(90, 95, "<=", "Aroused").on()
			.addRange(100, 95, ">", "Passionate").on();

		options.addOption("Sex drive", "energy", slave)
			.addRange(5, 10, "<=", "Frigid").off()
			.addRange(25, 40, "<=", "Poor").off()
			.addRange(45, 60, "<=", "Average").neutral()
			.addRange(65, 80, "<=", "Powerful").on()
			.addRange(85, 99, "<=", "Sex addict").on()
			.addRange(100, 99, ">", "Nympho").on();
	}

	if (slave.fetish !== "mindbroken") {
		options.addOption("Behavioral Flaw", "behavioralFlaw", slave)
			.addValueList([["None", "none"], ["Arrogant", "arrogant"], ["Bitchy", "bitchy"], ["Odd", "odd"], ["Hates Men", "hates men"],
				["Hates Women", "hates women"], ["Anorexic", "anorexic"], ["Gluttonous", "gluttonous"], ["Devout", "devout"],
				["Liberated", "liberated"]]);

		options.addOption("Behavioral Quirk", "behavioralQuirk", slave)
			.addValueList([["None", "none"], ["Confident", "confident"], ["Cutting", "cutting"], ["Funny", "funny"],
				["Adores Men", "adores men"], ["Adores Women", "adores women"], ["Insecure", "insecure"], ["Fitness", "fitness"],
				["Sinful", "sinful"], ["Advocate", "advocate"]]);

		options.addOption("Sexual Flaw", "sexualFlaw", slave)
			.addValueList([["None", "none"], ["Hates Oral", "hates oral"], ["Hates Anal", "hates anal"],
				["Hates Penetration", "hates penetration"], ["Repressed", "repressed"], ["Shamefast", "shamefast"], ["Apathetic", "apathetic"],
				["Crude", "crude"], ["Judgemental", "judgemental"], ["Sexually idealistic", "idealistic"]]);

		options.addOption("Sexual Quirk", "sexualQuirk", slave)
			.addValueList([["None", "none"], ["Oral", "gagfuck queen"], ["Anal", "painal queen"], ["Penetration", "strugglefuck queen"],
				["Perverted", "perverted"], ["Tease", "tease"], ["Caring", "caring"], ["Unflinching", "unflinching"], ["Size queen", "size queen"],
				["Romantic", "romantic"]]);
	}

	el.append(options.render());

	return el;
};
