App.UI.Budget.Cost = function() {
	let coloredRow = true;

	// Set up object to track calculated displays
	const income = "lastWeeksCashIncome";
	const expenses = "lastWeeksCashExpenses";

	const table = document.createElement("table");
	table.classList.add("budget");

	// HEADER
	generateHeader();

	// BODY
	table.createTBody();

	// HEADER: FACILITIES
	createSectionHeader("Facilities");

	const f = App.Entity.facilities; // shortcut

	// PENTHOUSE
	addToggle(generateRowGroup("Penthouse", "PENTHOUSE"), [
		generateRowCategory("Rest", "slaveAssignmentRest"),
		generateRowCategory("RestVign", "slaveAssignmentRestVign"),
		generateRowCategory("Fucktoy", "slaveAssignmentFucktoy"),
		generateRowCategory("Classes", "slaveAssignmentClasses"),
		generateRowCategory("House", "slaveAssignmentHouse"),
		generateRowCategory("HouseVign", "slaveAssignmentHouseVign"),
		generateRowCategory("Whore", "slaveAssignmentWhore"),
		generateRowCategory("WhoreVign", "slaveAssignmentWhoreVign"),
		generateRowCategory("Public", "slaveAssignmentPublic"),
		generateRowCategory("PublicVign", "slaveAssignmentPublicVign"),
		generateRowCategory("Subordinate", "slaveAssignmentSubordinate"),
		generateRowCategory("Milked", "slaveAssignmentMilked"),
		generateRowCategory("MilkedVign", "slaveAssignmentMilkedVign"),
		generateRowCategory("ExtraMilk", "slaveAssignmentExtraMilk"),
		generateRowCategory("ExtraMilkVign", "slaveAssignmentExtraMilkVign"),
		generateRowCategory("Gloryhole", "slaveAssignmentGloryhole"),
		generateRowCategory("Confinement", "slaveAssignmentConfinement")
	]);
	// Other
	generateRowCategory("Choosing Own Assignment", "slaveAssignmentChoice");

	// LEADERSHIP ROLES

	// HEAD GIRL
	// find passage name for HGSuite
	addToggle(generateRowGroup(f.headGirlSuite.nameCaps, "HEADGIRLSUITE"), [
		generateRowCategory("Head Girl", "slaveAssignmentHeadgirl"),
		generateRowCategory("Head Girl Fucktoys", "slaveAssignmentHeadgirlsuite")
	]);

	// RECRUITER
	addToggle(generateRowGroup("Recruiter", "RECRUITER"), [
		generateRowCategory("Recruiter", "slaveAssignmentRecruiter")
	]);

	// BODYGUARD
	// find passage name for Armory
	addToggle(generateRowGroup(f.armory.nameCaps, "DOJO"), [
		generateRowCategory("Bodyguard", "slaveAssignmentBodyguard")
	]);

	// CONCUBINE
	addToggle(generateRowGroup(f.masterSuite.nameCaps, "MASTERSUITE"), [
		generateRowCategory("Master Suite Operation", "masterSuite"),
		generateRowCategory("Master Suite Concubine", "slaveAssignmentConcubine"),
		generateRowCategory("Master Suite Fucktoys", "slaveAssignmentMastersuite")
	]);

	// AGENT
	addToggle(generateRowGroup("Agent", "AGENT"), [
		generateRowCategory("Agent", "slaveAssignmentAgent"),
		generateRowCategory("Agent's Partner", "slaveAssignmentAgentPartner")
	]);

	// ARCADE
	addToggle(generateRowGroup(f.arcade.nameCaps, "ARCADE"), [
		generateRowCategory("Arcade Operation", "arcade"),
		generateRowCategory("Arcade Fuckdolls", "slaveAssignmentArcade")
	]);

	// BROTHEL
	addToggle(generateRowGroup(f.brothel.nameCaps, "BROTHEL"), [
		generateRowCategory("Brothel Operation", "brothel"),
		generateRowCategory("Brothel Madam", "slaveAssignmentMadam"),
		generateRowCategory("Brothel MadamVign", "slaveAssignmentMadamVign"),
		generateRowCategory("Brothel Whore", "slaveAssignmentBrothel"),
		generateRowCategory("Brothel WhoreVign", "slaveAssignmentBrothelVign"),
		generateRowCategory("Brothel Ads", "brothelAds")
	]);

	// CELLBLOCK
	addToggle(generateRowGroup(f.cellblock.nameCaps, "CELLBLOCK"), [
		generateRowCategory("Cellblock Operation", "cellblock"),
		generateRowCategory("Cellblock Warden", "slaveAssignmentWarden"),
		generateRowCategory("Cellblock Slaves", "slaveAssignmentCellblock")
	]);

	// CLUB
	addToggle(generateRowGroup(f.club.nameCaps, "CLUB"), [
		generateRowCategory("Club Operation", "club"),
		generateRowCategory("Club DJ", "slaveAssignmentDj"),
		generateRowCategory("Club DJVign", "slaveAssignmentDjVign"),
		generateRowCategory("Club Public", "slaveAssignmentClub"),
		generateRowCategory("Club PublicVign", "slaveAssignmentClubVign"),
		generateRowCategory("Club Ads", "clubAds")
	]);

	// CLINIC
	addToggle(generateRowGroup(f.clinic.nameCaps, "CLINIC"), [
		generateRowCategory("Clinic Operation", "clinic"),
		generateRowCategory("Clinic Nurse", "slaveAssignmentNurse"),
		generateRowCategory("Clinic Slaves", "slaveAssignmentClinic")
	]);

	// DAIRY
	addToggle(generateRowGroup(f.dairy.nameCaps, "DAIRY"), [
		generateRowCategory("Dairy Operation", "dairy"),
		generateRowCategory("Dairy Milkmaid", "slaveAssignmentMilkmaid"),
		generateRowCategory("Dairy Cows", "slaveAssignmentDairy"),
		generateRowCategory("Dairy Cows", "slaveAssignmentDairyVign")
	]);

	// FARMYARD
	addToggle(generateRowGroup(f.farmyard.nameCaps, "FARMYARD"), [
		generateRowCategory("Farmyard Operation", "farmyard"),
		generateRowCategory("Farmyard Farmer", "slaveAssignmentFarmer"),
		generateRowCategory("Farmyard Farmhands", "slaveAssignmentFarmyard"),
		generateRowCategory("Farmyard FarmhandsVign", "slaveAssignmentFarmyardVign")
	]);

	// INCUBATOR
	addToggle(generateRowGroup(f.incubator.nameCaps, "INCUBATOR"), [
		generateRowCategory("Incubator Operation", "incubator"),
		generateRowCategory("Incubator Babies", "incubatorSlaves")
	]);

	// NURSERY
	addToggle(generateRowGroup(f.nursery.nameCaps, "NURSERY"), [
		generateRowCategory("Nursery Operation", "nursery"),
		generateRowCategory("Nursery Matron", "slaveAssignmentMatron"),
		generateRowCategory("Nursery Nannies", "slaveAssignmentNursery"),
		generateRowCategory("Nursery NanniesVign", "slaveAssignmentNurseryVign")
	]);

	// PIT
	addToggle(generateRowGroup(f.pit.nameCaps, "PIT"), [
		generateRowCategory("Pit Operation", "pit")
	]);

	// PROSTHETIC LAB
	addToggle(generateRowGroup("Prosthetic Lab", "PROSTHETICLAB"), [
		generateRowCategory("Prosthetic Lab Operation", "lab"),
		generateRowCategory("Prosthetic Lab Research", "labResearch"),
		generateRowCategory("Prosthetic Lab Scientists", "labScientists"),
		generateRowCategory("Prosthetic Lab Menials", "labMenials")
	]);

	// SCHOOLROOM
	addToggle(generateRowGroup(f.schoolroom.nameCaps, "SCHOOLROOM"), [
		generateRowCategory("Schoolroom Operation", "school"),
		generateRowCategory("Schoolroom Teacher", "slaveAssignmentTeacher"),
		generateRowCategory("Schoolroom Students", "slaveAssignmentSchool")
	]);

	// SERVANTS' QUARTERS
	addToggle(generateRowGroup(f.servantsQuarters.nameCaps, "SERVANTSQUARTERS"), [
		generateRowCategory("Servants' Quarters Operation", "servantsQuarters"),
		generateRowCategory("Servants' Quarters Steward", "slaveAssignmentSteward"),
		generateRowCategory("Servants' Quarters Servants", "slaveAssignmentQuarter"),
		generateRowCategory("Servants' Quarters ServantsVign", "slaveAssignmentQuarterVign")
	]);

	// SPA
	addToggle(generateRowGroup(f.spa.nameCaps, "SPA"), [
		generateRowCategory("Spa Operation", "spa"),
		generateRowCategory("Spa Attendant", "slaveAssignmentAttendant"),
		generateRowCategory("Spa Slaves", "slaveAssignmentSpa")
	]);

	// HEADER: ARCOLOGY
	createSectionHeader("Arcology");

	// SLAVES
	addToggle(generateRowGroup("Miscellaneous Slave Income and Expenses", "SLAVES"), [
		generateRowCategory("Slave Porn", "porn"),
		generateRowCategory("Slave Modifications", "slaveMod"),
		generateRowCategory("Slave Surgery", "slaveSurgery"),
		generateRowCategory("Slave Birthing", "birth")
	]);

	// MENIAL LABOR
	addToggle(generateRowGroup("Menial Labor", "LABOR"), [
		generateRowCategory("Menials: Slaves", "menialTrades"),
		generateRowCategory("Menials: Fuckdolls", "fuckdolls"),
		generateRowCategory("Menials: Bioreactors", "menialBioreactors")
	]);

	// FLIPPING
	addToggle(generateRowGroup("Flipping", "FLIPPING"), [
		generateRowCategory("Slave Transfer", "slaveTransfer"),
		generateRowCategory("Menials", "menialTransfer"),
		generateRowCategory("Fuckdolls", "fuckdollsTransfer"),
		generateRowCategory("Bioreactors", "menialBioreactorsTransfer"),
		generateRowCategory("Assistant: Menials", "menialTransferA"),
		generateRowCategory("Assistant: Fuckdolls", "fuckdollsTransferA"),
		generateRowCategory("Assistant: Bioreactors", "menialBioreactorsTransferA"),
		generateRowCategory("Menial Retirement", "menialRetirement"),
		generateRowCategory("Scientist Transfer", "labScientistsTransfer"),
		generateRowCategory("Slave Babies", "babyTransfer")
	]);

	// FINANCIALS
	addToggle(generateRowGroup("Financials", "FINANCIALS"), [
		generateRowCategory("Weather", "weather"),
		generateRowCategory("Rents", "rents"),
		generateRowCategory("Fines", "fines"),
		generateRowCategory("Events", "event"),
		generateRowCategory("Capital Expenses", "capEx"),
		generateRowCategory("Future Society Shaping", "futureSocieties"),
		generateRowCategory("School Subsidy", "schoolBacking"),
		generateRowCategory("Arcology conflict", "war"),
		generateRowCategory("Cheating", "cheating")
	]);

	// POLICIES
	addToggle(generateRowGroup("Policies", "POLICIES"), [
		generateRowCategory("Policies", "policies"),
		generateRowCategory("Subsidies and Barriers", "subsidiesAndBarriers")
	]);

	// EDICTS
	addToggle(generateRowGroup("Edicts", "EDICTS"), [
		generateRowCategory("Edicts", "edicts")
	]);

	// PERSONAL FINANCE
	addToggle(generateRowGroup("Personal Finance", "PERSONALFINANCE"), [
		generateRowCategory("Personal Business", "personalBusiness"),
		generateRowCategory("Personal Living Expenses", "personalLivingExpenses"),
		generateRowCategory("Your skills", "PCSkills"),
		generateRowCategory("Your training expenses", "PCtraining"),
		generateRowCategory("Your medical expenses", "PCmedical"),
		generateRowCategory("Citizen Orphanage", "citizenOrphanage"),
		generateRowCategory("Private Orphanage", "privateOrphanage"),
		generateRowCategory("Stock dividends", "stocks"),
		generateRowCategory("Stock trading", "stocksTraded")
	]);

	// SECURITY
	addToggle(generateRowGroup("Security", "SECURITY"), [
		generateRowCategory("Mercenaries", "mercenaries"),
		generateRowCategory("Security Expansion", "securityExpansion"),
		generateRowCategory("Special Forces", "specialForces"),
		generateRowCategory("Special Forces Capital Expenses", "specialForcesCap"),
		generateRowCategory("Peacekeepers", "peacekeepers")
	]);

	// BUDGET REPORT
	generateSummary();

	return table;

	function generateHeader() {
		const header = table.createTHead();
		const row = header.insertRow();
		const cell = row.insertCell();
		let pent = document.createElement("h1");
		pent.textContent = "Budget Overview";
		cell.appendChild(pent);

		for (let column of ["Income", "Expense", "Totals"]) {
			let cell = document.createElement("th");
			cell.textContent = column;
			row.appendChild(cell);
		}
	}

	function generateSummary() {
		let row, cell;
		createSectionHeader("Budget Report");

		row = table.insertRow();
		cell = row.insertCell();
		cell.append("Tracked totals");

		cell = row.insertCell();
		V.lastWeeksCashIncome.Total = hashSum(V.lastWeeksCashIncome);
		cell.append(cashFormatColorDOM(Math.trunc(V.lastWeeksCashIncome.Total)));

		cell = row.insertCell();
		V.lastWeeksCashExpenses.Total = hashSum(V.lastWeeksCashExpenses);
		cell.append(cashFormatColorDOM(Math.trunc(V.lastWeeksCashExpenses.Total)));

		cell = row.insertCell();
		cell.append(cashFormatColorDOM(Math.trunc(V.lastWeeksCashIncome.Total + V.lastWeeksCashExpenses.Total)));
		flipColors(row);

		row = table.insertRow();
		cell = row.insertCell();
		cell.append(`Expenses budget for week ${V.week + 1}`);
		cell = row.insertCell();
		cell = row.insertCell();
		cell.append(cashFormatColorDOM(-V.costs));
		flipColors(row);

		row = table.insertRow();
		cell = row.insertCell();
		cell.append(`Last week actuals`);
		cell = row.insertCell();
		cell = row.insertCell();
		cell = row.insertCell();
		cell.append(cashFormatColorDOM(V.cash - V.cashLastWeek));
		flipColors(row);

		row = table.insertRow();
		if ((V.cash - V.cashLastWeek) === (V.lastWeeksCashIncome.Total + V.lastWeeksCashExpenses.Total)) {
			cell = row.insertCell();
			const span = document.createElement('span');
			span.className = "green";
			span.textContent = `The books are balanced, ${properTitle()}!`;
			cell.append(span);
		} else {
			cell = row.insertCell();
			cell.append("Transaction tracking off by:");
			cell = row.insertCell();
			cell = row.insertCell();
			cell = row.insertCell();
			cell.append(cashFormatColorDOM((V.cash - V.cashLastWeek) - (V.lastWeeksCashIncome.Total + V.lastWeeksCashExpenses.Total)));
		}
		flipColors(row);
	}

	function createSectionHeader(text) {
		coloredRow = true; // make sure the following section begins with color.
		const row = table.insertRow();
		const cell = row.insertCell();
		const headline = document.createElement('h2');
		headline.textContent = text;
		cell.append(headline);
	}

	function generateRowCategory(node, category) {
		if (category === "") {
			const row = table.insertRow();
			row.append(document.createElement('br'));
			row.insertCell();
			row.insertCell();
			row.insertCell();
			flipColors(row);
			return row;
		}

		if (V[income][category] || V[expenses][category] || V.showAllEntries.costsBudget) {
			const row = table.insertRow();
			let cell = row.insertCell();
			cell.append(node);
			cell = row.insertCell();
			cell.append(cashFormatColorDOM(V[income][category]));
			cell = row.insertCell();
			cell.append(cashFormatColorDOM(-Math.abs(V[expenses][category])));
			flipColors(row);
			cell = row.insertCell();
			cell.append(cashFormatColorDOM(V[income][category] + V[expenses][category]));
			return row;
		}
	}

	function generateRowGroup(title, name) {
		/** @type {string[]} */
		const members = CategoryAssociatedGroup[name];
		const groupIn = members.map((k) => V[income][k]).reduce((acc, cur) => acc + cur);
		const groupEx = members.map((k) => V[expenses][k]).reduce((acc, cur) => acc + cur);

		if (groupIn || groupEx || V.showAllEntries.costsBudget) {
			const row = table.insertRow();
			let cell = row.insertCell();
			const headline = document.createElement('h3');
			headline.textContent = title;
			cell.append(headline);
			cell = row.insertCell();
			cell.append(cashFormatColorDOM(groupIn));
			cell = row.insertCell();
			cell.append(cashFormatColorDOM(groupEx));
			cell = row.insertCell();
			cell.append(cashFormatColorDOM(groupIn + groupEx));
			return row;
		}
	}

	/**
	 * @param {HTMLTableRowElement} head
	 * @param {Array<HTMLTableRowElement>} content
	 */
	function addToggle(head, content) {
		if (!head) {
			return;
		}
		content = content.filter(e => !!e);
		if (content.length === 0) {
			return;
		}
		App.UI.DOM.elementToggle(head, content);
	}

	function cashFormatColorDOM(cash, invert = false) {
		if (invert) {
			cash = -1 * cash;
		}
		let span = document.createElement('span');
		span.textContent = cashFormat(cash);
		if (cash === 0) {
			// cash overwrites gray, so we don't use it here.
			span.classList.add("gray");
		} else {
			span.classList.add("cash");
			// Display red if the value is negative, unless invert is true
			if (cash < 0) {
				span.classList.add("dec");
				// Yellow for positive
			} else if (cash > 0) {
				span.classList.add("inc");
				// Gray for exactly zero
			}
		}
		return span;
	}

	function flipColors(row) {
		if (coloredRow) {
			row.classList.add("colored");
		}
		coloredRow = !coloredRow;
	}
};
